#' @include system_stochastic_adjustment.R


setGeneric("partial_own_price", function(object) {
  standardGeneric("partial_own_price")
})

setMethod("partial_own_price", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  (object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@zeta_SS**4 * (object@supply@alpha**2 * object@h_S * object@sigma_P**3 * object@zeta**2 + object@sigma_P * (2 * object@supply@alpha * object@mu_P * object@sigma_S * object@zeta**2 + object@h_S * object@var_S * object@zeta**2 - object@h_S * object@supply@sigma**2 * object@zeta**2)) + object@var_S * (object@zeta_SS**(5 / 2) * (object@sigma_D * (-2 * object@omega_D * object@rho_DP * object@cov_DP * object@zeta**2 + object@var_P * (-2 * object@supply@alpha * object@omega_D * object@rho_DP * object@zeta**2 - 2 * object@gamma * object@omega_D * object@rho_DP * object@zeta**2)) + object@sigma_P**3 * (object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@omega_D * object@rho_DP**2 * object@zeta**2) + object@sigma_P * (2 * object@gamma * object@omega_D * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 2 * object@omega_D * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + 3 * object@omega_D * object@rho_DP**2 * object@var_D * object@zeta**2 + object@omega_D * object@rho_DP**2 * object@demand@sigma**2 * object@zeta**2)) + object@zeta_SS**3 * (-2 * object@mu_P * object@var_D * object@zeta**2 * object@zeta_SP + object@sigma_D * (-2 * object@h_D * object@rho_SP * object@cov_DP * object@zeta**2 - 2 * object@h_P * object@rho_DS * object@cov_DP * object@zeta**2 + 4 * object@h_S * object@rho_DP * object@cov_DP * object@zeta**2 + object@var_P * (-2 * object@supply@alpha * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@supply@alpha * object@h_P * object@rho_DS * object@zeta**2 + 4 * object@supply@alpha * object@h_S * object@rho_DP * object@zeta**2 - 2 * object@gamma * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@gamma * object@h_P * object@rho_DS * object@zeta**2 + 4 * object@gamma * object@h_S * object@rho_DP * object@zeta**2)) + object@sigma_P**3 * (object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@h_D * object@zeta**2 * object@zeta_DS + 2 * object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 4 * object@demand@alpha * object@delta * object@h_S * object@rho_DP**2 * object@zeta**2) + object@sigma_P * (2 * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 2 * object@gamma * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 * object@zeta_DS + 2 * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@gamma * object@h_S * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma**2 * object@zeta**2 + 2 * object@h_D * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 * object@zeta_DS - object@h_D * object@demand@sigma**2 * object@zeta**2 * object@zeta_DS - 2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma**2 * object@zeta**2 + 4 * object@h_S * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 - 2 * object@h_S * object@rho_DP**2 * object@demand@sigma**2 * object@zeta**2 + object@var_D * (3 * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@h_D * object@zeta**2 * object@zeta_DS + 3 * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@h_P * object@zeta**2 * object@zeta_SP - 6 * object@h_S * object@rho_DP**2 * object@zeta**2) + object@sigma_D * (-2 * object@supply@alpha * object@mu_P * object@zeta**2 * object@zeta_DS - 2 * object@gamma * object@mu_P * object@zeta**2 * object@zeta_DS)))) + object@zeta_SS**(7 / 2) * (-2 * object@omega_D * object@sigma_D * object@cov_DP * object@var_S * object@zeta_DP + object@var_D * object@sigma_S * (-2 * object@omega_D * object@cov_SP * object@zeta_SP + 2 * object@cov_SP * object@z_PD * object@zeta**2) + object@sigma_P**3 * (object@var_D * (object@supply@alpha**2 * object@omega_D * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@omega_D * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@rho_SP * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@z_DP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_D * object@zeta_DS + 2 * object@supply@alpha * object@delta * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@rho_DS * object@z_DP * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@omega_D * object@rho_DP * object@zeta_DP + 2 * object@demand@alpha * object@delta * object@omega_D * object@rho_DS * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@rho_DS * object@z_DP * object@zeta**2)) + object@var_P * (object@var_D * object@sigma_S * (-2 * object@supply@alpha * object@omega_D * object@zeta_SP + 2 * object@supply@alpha * object@z_PD * object@zeta**2) + object@sigma_D * object@var_S * (-2 * object@supply@alpha * object@omega_D * object@zeta_DP - 2 * object@gamma * object@omega_D * object@zeta_DP)) + object@sigma_P * (object@var_D * (-object@omega_D * object@rho_DS * object@supply@sigma**2 * object@zeta_DS - object@omega_D * object@rho_SP * object@supply@sigma**2 * object@zeta_SP + object@rho_DS * object@supply@sigma**2 * object@z_DP * object@zeta**2 + object@rho_SP * object@supply@sigma**2 * object@z_PD * object@zeta**2 + object@var_S * (3 * object@omega_D * object@rho_DP * object@zeta_DP + 2 * object@omega_D * object@rho_DS * object@zeta_DS + 3 * object@omega_D * object@rho_SP * object@zeta_SP - 2 * object@rho_DS * object@z_DP * object@zeta**2 - 3 * object@rho_SP * object@z_PD * object@zeta**2)) + object@sigma_D * object@sigma_S * (-2 * object@gamma * object@omega_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS + 2 * object@gamma * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**2 - 2 * object@omega_D * object@cov_DS * object@zeta_DS + 2 * object@omega_D * object@supply@sigma**2 * object@zeta_DS + 2 * object@cov_DS * object@z_DP * object@zeta**2 - 2 * object@supply@sigma**2 * object@z_DP * object@zeta**2) + object@var_S * (2 * object@gamma * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP + 2 * object@gamma * object@omega_D * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 2 * object@gamma * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@omega_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DP + object@omega_D * object@rho_DP * object@demand@sigma**2 * object@zeta_DP - 2 * object@omega_D * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DS + object@omega_D * object@rho_DS * object@demand@sigma**2 * object@zeta_DS + 2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_DP * object@zeta**2 - object@rho_DS * object@demand@sigma**2 * object@z_DP * object@zeta**2)))) + object@var_S * (object@zeta_SS**(7 / 2) * (object@sigma_P**3 * (-object@demand@alpha**2 * object@zeta**3 - 2 * object@demand@alpha * object@delta * object@zeta**3) + object@sigma_P * (-2 * object@gamma * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**3 - 3 * object@var_D * object@zeta**3 - object@demand@sigma**2 * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@sigma_D * (-2 * object@h_D * object@h_P * object@cov_DP * object@zeta**3 + 2 * object@rho_DP * object@cov_DP * object@zeta**3 + object@var_P * (-2 * object@supply@alpha * object@h_D * object@h_P * object@zeta**3 + 2 * object@supply@alpha * object@rho_DP * object@zeta**3 - 2 * object@gamma * object@h_D * object@h_P * object@zeta**3 + 2 * object@gamma * object@rho_DP * object@zeta**3)) + object@sigma_P**3 * (object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha**2 * object@rho_DP**2 * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - 2 * object@demand@alpha * object@delta * object@rho_DP**2 * object@zeta**3) + object@sigma_P * (2 * object@gamma * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@gamma * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@h_D * object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**3 + object@h_D * object@h_P * object@rho_DP * object@demand@sigma**2 * object@zeta**3 + 2 * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**3 - object@rho_DP**2 * object@demand@sigma**2 * object@zeta**3 + object@var_D * (3 * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - 3 * object@rho_DP**2 * object@zeta**3))) + object@zeta_SS**3 * (2 * object@mu_P * object@var_D * object@z_PD * object@zeta**3 + object@sigma_P**3 * (object@demand@alpha**2 * object@h_D * object@z_DP * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@h_D * object@z_DP * object@zeta**3) + object@sigma_P * (2 * object@gamma * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 - 2 * object@h_D * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_DP * object@zeta**3 + object@h_D * object@demand@sigma**2 * object@z_DP * object@zeta**3 + object@var_D * (object@h_D * object@z_DP * object@zeta**3 + 2 * object@h_P * object@z_PD * object@zeta**3) + object@sigma_D * (2 * object@supply@alpha * object@mu_P * object@z_DP * object@zeta**3 + 2 * object@gamma * object@mu_P * object@z_DP * object@zeta**3))) + object@zeta_SS**2 * (object@sigma_D * (2 * object@h_D * object@cov_DP * object@z_PD * object@zeta**3 + 2 * object@h_P * object@cov_DP * object@z_DP * object@zeta**3 + object@var_P * (2 * object@supply@alpha * object@h_D * object@z_PD * object@zeta**3 + 2 * object@supply@alpha * object@h_P * object@z_DP * object@zeta**3 + 2 * object@gamma * object@h_D * object@z_PD * object@zeta**3 + 2 * object@gamma * object@h_P * object@z_DP * object@zeta**3)) + object@sigma_P**3 * (-object@demand@alpha**2 * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@z_DP * object@zeta**3 - 2 * object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - 2 * object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@z_DP * object@zeta**3) + object@sigma_P * (-2 * object@gamma * object@h_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**3 - 2 * object@gamma * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 + 2 * object@h_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_PD * object@zeta**3 - object@h_D * object@rho_DP * object@demand@sigma**2 * object@z_PD * object@zeta**3 + 2 * object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_DP * object@zeta**3 - object@h_P * object@rho_DP * object@demand@sigma**2 * object@z_DP * object@zeta**3 + object@var_D * (-3 * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - 3 * object@h_P * object@rho_DP * object@z_DP * object@zeta**3))))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@sigma_P**3 * object@zeta**2 + object@sigma_P * (3 * object@omega_S * object@rho_SP**2 * object@var_S * object@zeta**2 - object@omega_S * object@rho_SP**2 * object@supply@sigma**2 * object@zeta**2) + object@sigma_S * (-2 * object@supply@alpha * object@omega_S * object@rho_SP * object@var_P * object@zeta**2 - 2 * object@omega_S * object@rho_SP * object@cov_SP * object@zeta**2)) + object@zeta_DD**3 * (-2 * object@mu_P * object@var_S * object@zeta**2 * object@zeta_DP + object@sigma_P**3 * (-2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@zeta**2 + object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_P * (-2 * object@supply@alpha * object@mu_P * object@sigma_S * object@zeta**2 * object@zeta_DS + 2 * object@h_D * object@rho_SP**2 * object@supply@sigma**2 * object@zeta**2 - object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma**2 * object@zeta**2 - object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma**2 * object@zeta**2 + object@h_S * object@supply@sigma**2 * object@zeta**2 * object@zeta_DS + object@var_S * (-6 * object@h_D * object@rho_SP**2 * object@zeta**2 + 3 * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - 2 * object@h_P * object@zeta**2 * object@zeta_DP + 3 * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@h_S * object@zeta**2 * object@zeta_DS)) + object@sigma_S * (4 * object@h_D * object@rho_SP * object@cov_SP * object@zeta**2 - 2 * object@h_P * object@rho_DS * object@cov_SP * object@zeta**2 - 2 * object@h_S * object@rho_DP * object@cov_SP * object@zeta**2 + object@var_P * (4 * object@supply@alpha * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@supply@alpha * object@h_P * object@rho_DS * object@zeta**2 - 2 * object@supply@alpha * object@h_S * object@rho_DP * object@zeta**2)))) + object@var_S * object@zeta_DD**4 * (object@sigma_P**3 * (object@demand@alpha**2 * object@h_D * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@h_D * object@zeta**2) + object@sigma_P * (2 * object@gamma * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 2 * object@h_D * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + object@h_D * object@var_D * object@zeta**2 + object@h_D * object@demand@sigma**2 * object@zeta**2 + object@sigma_D * (2 * object@supply@alpha * object@mu_P * object@zeta**2 + 2 * object@gamma * object@mu_P * object@zeta**2))) + object@zeta_DD**(7 / 2) * (-2 * object@omega_S * object@var_D * object@sigma_S * object@cov_SP * object@zeta_SP + object@sigma_D * object@var_S * (-2 * object@omega_S * object@cov_DP * object@zeta_DP + 2 * object@cov_DP * object@z_PS * object@zeta**2) + object@sigma_P**3 * (object@var_D * (object@supply@alpha**2 * object@omega_S * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@omega_S * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@z_SP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_S * object@zeta_DS + 2 * object@supply@alpha * object@delta * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@rho_DS * object@z_SP * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@omega_S * object@rho_DP * object@zeta_DP + 2 * object@demand@alpha * object@delta * object@omega_S * object@rho_DS * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@rho_DP * object@z_PS * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@rho_DS * object@z_SP * object@zeta**2)) + object@var_P * (-2 * object@supply@alpha * object@omega_S * object@var_D * object@sigma_S * object@zeta_SP + object@sigma_D * object@var_S * (-2 * object@supply@alpha * object@omega_S * object@zeta_DP + 2 * object@supply@alpha * object@z_PS * object@zeta**2 - 2 * object@gamma * object@omega_S * object@zeta_DP + 2 * object@gamma * object@z_PS * object@zeta**2)) + object@sigma_P * (object@var_D * (-object@omega_S * object@rho_DS * object@supply@sigma**2 * object@zeta_DS - object@omega_S * object@rho_SP * object@supply@sigma**2 * object@zeta_SP + object@rho_DS * object@supply@sigma**2 * object@z_SP * object@zeta**2 + object@var_S * (3 * object@omega_S * object@rho_DP * object@zeta_DP + 2 * object@omega_S * object@rho_DS * object@zeta_DS + 3 * object@omega_S * object@rho_SP * object@zeta_SP - 3 * object@rho_DP * object@z_PS * object@zeta**2 - 2 * object@rho_DS * object@z_SP * object@zeta**2)) + object@sigma_D * object@sigma_S * (-2 * object@gamma * object@omega_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS + 2 * object@gamma * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**2 - 2 * object@omega_S * object@cov_DS * object@zeta_DS + 2 * object@omega_S * object@supply@sigma**2 * object@zeta_DS + 2 * object@cov_DS * object@z_SP * object@zeta**2 - 2 * object@supply@sigma**2 * object@z_SP * object@zeta**2) + object@var_S * (2 * object@gamma * object@omega_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP + 2 * object@gamma * object@omega_S * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 2 * object@gamma * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**2 - 2 * object@gamma * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@omega_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DP + object@omega_S * object@rho_DP * object@demand@sigma**2 * object@zeta_DP - 2 * object@omega_S * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DS + object@omega_S * object@rho_DS * object@demand@sigma**2 * object@zeta_DS + 2 * object@rho_DP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_PS * object@zeta**2 - object@rho_DP * object@demand@sigma**2 * object@z_PS * object@zeta**2 + 2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_SP * object@zeta**2 - object@rho_DS * object@demand@sigma**2 * object@z_SP * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (-object@supply@alpha**2 * object@sigma_P**3 * object@zeta**3 + object@sigma_P * (-3 * object@var_S * object@zeta**3 + object@supply@sigma**2 * object@zeta**3)) + object@zeta_DD**(5 / 2) * (object@sigma_P**3 * (object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@supply@alpha**2 * object@rho_SP**2 * object@zeta**3) + object@sigma_P * (-object@h_P * object@h_S * object@rho_SP * object@supply@sigma**2 * object@zeta**3 + object@rho_SP**2 * object@supply@sigma**2 * object@zeta**3 + object@var_S * (3 * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - 3 * object@rho_SP**2 * object@zeta**3)) + object@sigma_S * (-2 * object@h_P * object@h_S * object@cov_SP * object@zeta**3 + 2 * object@rho_SP * object@cov_SP * object@zeta**3 + object@var_P * (-2 * object@supply@alpha * object@h_P * object@h_S * object@zeta**3 + 2 * object@supply@alpha * object@rho_SP * object@zeta**3))) + object@zeta_DD**3 * (object@supply@alpha**2 * object@h_S * object@sigma_P**3 * object@z_SP * object@zeta**3 + 2 * object@mu_P * object@var_S * object@z_PS * object@zeta**3 + object@sigma_P * (2 * object@supply@alpha * object@mu_P * object@sigma_S * object@z_SP * object@zeta**3 - object@h_S * object@supply@sigma**2 * object@z_SP * object@zeta**3 + object@var_S * (2 * object@h_P * object@z_PS * object@zeta**3 + object@h_S * object@z_SP * object@zeta**3))) + object@zeta_DD**2 * (object@sigma_P**3 * (-object@supply@alpha**2 * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_SP * object@z_PS * object@zeta**3) + object@sigma_P * (object@h_P * object@rho_SP * object@supply@sigma**2 * object@z_SP * object@zeta**3 + object@h_S * object@rho_SP * object@supply@sigma**2 * object@z_PS * object@zeta**3 + object@var_S * (-3 * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - 3 * object@h_S * object@rho_SP * object@z_PS * object@zeta**3)) + object@sigma_S * (2 * object@h_P * object@cov_SP * object@z_SP * object@zeta**3 + 2 * object@h_S * object@cov_SP * object@z_PS * object@zeta**3 + object@var_P * (2 * object@supply@alpha * object@h_P * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@h_S * object@z_PS * object@zeta**3)))))) / (2 * object@delta * object@var_D * object@sigma_P * object@var_S * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_own_controls", function(object) {
  standardGeneric("partial_own_controls")
})

setMethod("partial_own_controls", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  object@demand@control_matrix * c(object@L_D * sqrt(object@zeta_DD) * (object@g_D * (-object@sigma_D * object@sigma_S * object@zeta_SP + object@sigma_P * (object@supply@alpha * object@sigma_D * object@zeta_SS + object@sigma_S * (-object@supply@alpha * object@zeta_DS - object@gamma * object@zeta_DS))) + object@sigma_S * (object@sigma_D * object@z_PD * object@zeta + object@sigma_P * (object@supply@alpha * object@z_DP * object@zeta + object@gamma * object@z_DP * object@zeta))) + object@L_S * sqrt(object@zeta_SS) * (object@g_S * (-object@sigma_D * object@sigma_S * object@zeta_DP + object@sigma_P * (-object@supply@alpha * object@sigma_D * object@zeta_DS + object@sigma_S * object@zeta_DD * (object@supply@alpha + object@gamma))) + object@sigma_D * (object@supply@alpha * object@sigma_P * object@z_SP * object@zeta + object@sigma_S * object@z_PS * object@zeta))) / (object@delta * object@sigma_D * object@sigma_P * object@sigma_S * object@zeta * sqrt(object@zeta_DD) * sqrt(object@zeta_SS))
  # nolint end
})

setGeneric("partial_other_price", function(object) {
  standardGeneric("partial_other_price")
})

setMethod("partial_other_price", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  -(object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@zeta_SS**4 * (object@sigma_P**3 * (object@supply@alpha**2 * object@h_S * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_S * object@zeta**2) + object@sigma_P * (-2 * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@h_S * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + object@h_S * object@var_S * object@zeta**2 + object@h_S * object@supply@sigma**2 * object@zeta**2 + object@sigma_S * (2 * object@demand@alpha * object@mu_P * object@zeta**2 - 2 * object@gamma * object@mu_P * object@zeta**2))) + object@var_S * (object@zeta_SS**(5 / 2) * (object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@sigma_P**3 * object@zeta**2 + object@sigma_D * (-2 * object@demand@alpha * object@omega_D * object@rho_DP * object@var_P * object@zeta**2 - 2 * object@omega_D * object@rho_DP * object@cov_DP * object@zeta**2) + object@sigma_P * (3 * object@omega_D * object@rho_DP**2 * object@var_D * object@zeta**2 - object@omega_D * object@rho_DP**2 * object@demand@sigma**2 * object@zeta**2)) + object@zeta_SS**3 * (-2 * object@mu_P * object@var_D * object@zeta**2 * object@zeta_SP + object@sigma_D * (-2 * object@h_D * object@rho_SP * object@cov_DP * object@zeta**2 - 2 * object@h_P * object@rho_DS * object@cov_DP * object@zeta**2 + 4 * object@h_S * object@rho_DP * object@cov_DP * object@zeta**2 + object@var_P * (-2 * object@demand@alpha * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@demand@alpha * object@h_P * object@rho_DS * object@zeta**2 + 4 * object@demand@alpha * object@h_S * object@rho_DP * object@zeta**2)) + object@sigma_P**3 * (object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@zeta**2) + object@sigma_P * (-2 * object@demand@alpha * object@mu_P * object@sigma_D * object@zeta**2 * object@zeta_DS - object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma**2 * object@zeta**2 + object@h_D * object@demand@sigma**2 * object@zeta**2 * object@zeta_DS - object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma**2 * object@zeta**2 + 2 * object@h_S * object@rho_DP**2 * object@demand@sigma**2 * object@zeta**2 + object@var_D * (3 * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@h_D * object@zeta**2 * object@zeta_DS + 3 * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@h_P * object@zeta**2 * object@zeta_SP - 6 * object@h_S * object@rho_DP**2 * object@zeta**2)))) + object@zeta_SS**(7 / 2) * (-2 * object@omega_D * object@sigma_D * object@cov_DP * object@var_S * object@zeta_DP + object@var_D * object@sigma_S * (-2 * object@omega_D * object@cov_SP * object@zeta_SP + 2 * object@cov_SP * object@z_PD * object@zeta**2) + object@sigma_P**3 * (object@var_D * (object@supply@alpha**2 * object@omega_D * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@omega_D * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@rho_SP * object@z_PD * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_D * object@rho_DS * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@omega_D * object@rho_SP * object@zeta_SP + 2 * object@supply@alpha * object@delta * object@rho_DS * object@z_DP * object@zeta**2 + 2 * object@supply@alpha * object@delta * object@rho_SP * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@z_DP * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@omega_D * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@rho_DS * object@z_DP * object@zeta**2)) + object@var_P * (-2 * object@demand@alpha * object@omega_D * object@sigma_D * object@var_S * object@zeta_DP + object@var_D * object@sigma_S * (-2 * object@demand@alpha * object@omega_D * object@zeta_SP + 2 * object@demand@alpha * object@z_PD * object@zeta**2 + 2 * object@gamma * object@omega_D * object@zeta_SP - 2 * object@gamma * object@z_PD * object@zeta**2)) + object@sigma_P * (object@var_D * (-2 * object@gamma * object@omega_D * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@gamma * object@omega_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**2 + 2 * object@gamma * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**2 - 2 * object@omega_D * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DS + object@omega_D * object@rho_DS * object@supply@sigma**2 * object@zeta_DS - 2 * object@omega_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_SP + object@omega_D * object@rho_SP * object@supply@sigma**2 * object@zeta_SP + 2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_DP * object@zeta**2 - object@rho_DS * object@supply@sigma**2 * object@z_DP * object@zeta**2 + 2 * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_PD * object@zeta**2 - object@rho_SP * object@supply@sigma**2 * object@z_PD * object@zeta**2 + object@var_S * (3 * object@omega_D * object@rho_DP * object@zeta_DP + 2 * object@omega_D * object@rho_DS * object@zeta_DS + 3 * object@omega_D * object@rho_SP * object@zeta_SP - 2 * object@rho_DS * object@z_DP * object@zeta**2 - 3 * object@rho_SP * object@z_PD * object@zeta**2)) + object@sigma_D * object@sigma_S * (2 * object@gamma * object@omega_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 2 * object@gamma * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@omega_D * object@cov_DS * object@zeta_DS + 2 * object@omega_D * object@demand@sigma**2 * object@zeta_DS + 2 * object@cov_DS * object@z_DP * object@zeta**2 - 2 * object@demand@sigma**2 * object@z_DP * object@zeta**2) + object@var_S * (-object@omega_D * object@rho_DP * object@demand@sigma**2 * object@zeta_DP - object@omega_D * object@rho_DS * object@demand@sigma**2 * object@zeta_DS + object@rho_DS * object@demand@sigma**2 * object@z_DP * object@zeta**2)))) + object@var_S * (object@zeta_SS**(7 / 2) * (-object@demand@alpha**2 * object@sigma_P**3 * object@zeta**3 + object@sigma_P * (-3 * object@var_D * object@zeta**3 + object@demand@sigma**2 * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@sigma_D * (-2 * object@h_D * object@h_P * object@cov_DP * object@zeta**3 + 2 * object@rho_DP * object@cov_DP * object@zeta**3 + object@var_P * (-2 * object@demand@alpha * object@h_D * object@h_P * object@zeta**3 + 2 * object@demand@alpha * object@rho_DP * object@zeta**3)) + object@sigma_P**3 * (object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha**2 * object@rho_DP**2 * object@zeta**3) + object@sigma_P * (-object@h_D * object@h_P * object@rho_DP * object@demand@sigma**2 * object@zeta**3 + object@rho_DP**2 * object@demand@sigma**2 * object@zeta**3 + object@var_D * (3 * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - 3 * object@rho_DP**2 * object@zeta**3))) + object@zeta_SS**3 * (object@demand@alpha**2 * object@h_D * object@sigma_P**3 * object@z_DP * object@zeta**3 + 2 * object@mu_P * object@var_D * object@z_PD * object@zeta**3 + object@sigma_P * (2 * object@demand@alpha * object@mu_P * object@sigma_D * object@z_DP * object@zeta**3 - object@h_D * object@demand@sigma**2 * object@z_DP * object@zeta**3 + object@var_D * (object@h_D * object@z_DP * object@zeta**3 + 2 * object@h_P * object@z_PD * object@zeta**3))) + object@zeta_SS**2 * (object@sigma_D * (2 * object@h_D * object@cov_DP * object@z_PD * object@zeta**3 + 2 * object@h_P * object@cov_DP * object@z_DP * object@zeta**3 + object@var_P * (2 * object@demand@alpha * object@h_D * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@h_P * object@z_DP * object@zeta**3)) + object@sigma_P**3 * (-object@demand@alpha**2 * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@z_DP * object@zeta**3) + object@sigma_P * (object@h_D * object@rho_DP * object@demand@sigma**2 * object@z_PD * object@zeta**3 + object@h_P * object@rho_DP * object@demand@sigma**2 * object@z_DP * object@zeta**3 + object@var_D * (-3 * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - 3 * object@h_P * object@rho_DP * object@z_DP * object@zeta**3))))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@sigma_P**3 * (object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_S * object@rho_SP**2 * object@zeta**2) + object@sigma_P * (-2 * object@gamma * object@omega_S * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@omega_S * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + 3 * object@omega_S * object@rho_SP**2 * object@var_S * object@zeta**2 + object@omega_S * object@rho_SP**2 * object@supply@sigma**2 * object@zeta**2) + object@sigma_S * (-2 * object@omega_S * object@rho_SP * object@cov_SP * object@zeta**2 + object@var_P * (-2 * object@demand@alpha * object@omega_S * object@rho_SP * object@zeta**2 + 2 * object@gamma * object@omega_S * object@rho_SP * object@zeta**2))) + object@zeta_DD**3 * (-2 * object@mu_P * object@var_S * object@zeta**2 * object@zeta_DP + object@sigma_P**3 * (-2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@zeta**2 + object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@zeta**2 * object@zeta_DS + 4 * object@supply@alpha * object@delta * object@h_D * object@rho_SP**2 * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 + 2 * object@supply@alpha * object@delta * object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_P * (4 * object@gamma * object@h_D * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 * object@zeta_DS + 4 * object@h_D * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 - 2 * object@h_D * object@rho_SP**2 * object@supply@sigma**2 * object@zeta**2 - 2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma**2 * object@zeta**2 - 2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 + object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma**2 * object@zeta**2 + 2 * object@h_S * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**2 * object@zeta_DS - object@h_S * object@supply@sigma**2 * object@zeta**2 * object@zeta_DS + object@var_S * (-6 * object@h_D * object@rho_SP**2 * object@zeta**2 + 3 * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - 2 * object@h_P * object@zeta**2 * object@zeta_DP + 3 * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_S * (-2 * object@demand@alpha * object@mu_P * object@zeta**2 * object@zeta_DS + 2 * object@gamma * object@mu_P * object@zeta**2 * object@zeta_DS)) + object@sigma_S * (4 * object@h_D * object@rho_SP * object@cov_SP * object@zeta**2 - 2 * object@h_P * object@rho_DS * object@cov_SP * object@zeta**2 - 2 * object@h_S * object@rho_DP * object@cov_SP * object@zeta**2 + object@var_P * (4 * object@demand@alpha * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@demand@alpha * object@h_P * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha * object@h_S * object@rho_DP * object@zeta**2 - 4 * object@gamma * object@h_D * object@rho_SP * object@zeta**2 + 2 * object@gamma * object@h_P * object@rho_DS * object@zeta**2 + 2 * object@gamma * object@h_S * object@rho_DP * object@zeta**2)))) + object@var_S * object@zeta_DD**4 * (object@demand@alpha**2 * object@h_D * object@sigma_P**3 * object@zeta**2 + object@sigma_P * (2 * object@demand@alpha * object@mu_P * object@sigma_D * object@zeta**2 + object@h_D * object@var_D * object@zeta**2 - object@h_D * object@demand@sigma**2 * object@zeta**2)) + object@zeta_DD**(7 / 2) * (-2 * object@omega_S * object@var_D * object@sigma_S * object@cov_SP * object@zeta_SP + object@sigma_D * object@var_S * (-2 * object@omega_S * object@cov_DP * object@zeta_DP + 2 * object@cov_DP * object@z_PS * object@zeta**2) + object@sigma_P**3 * (object@var_D * (object@supply@alpha**2 * object@omega_S * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@omega_S * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@z_SP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_S * object@rho_DS * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@omega_S * object@rho_SP * object@zeta_SP + 2 * object@supply@alpha * object@delta * object@rho_DS * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@z_SP * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@omega_S * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@rho_DS * object@z_SP * object@zeta**2)) + object@var_P * (object@var_D * object@sigma_S * (-2 * object@demand@alpha * object@omega_S * object@zeta_SP + 2 * object@gamma * object@omega_S * object@zeta_SP) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@omega_S * object@zeta_DP + 2 * object@demand@alpha * object@z_PS * object@zeta**2)) + object@sigma_P * (object@var_D * (-2 * object@gamma * object@omega_S * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@gamma * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**2 - 2 * object@omega_S * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DS + object@omega_S * object@rho_DS * object@supply@sigma**2 * object@zeta_DS - 2 * object@omega_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_SP + object@omega_S * object@rho_SP * object@supply@sigma**2 * object@zeta_SP + 2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_SP * object@zeta**2 - object@rho_DS * object@supply@sigma**2 * object@z_SP * object@zeta**2 + object@var_S * (3 * object@omega_S * object@rho_DP * object@zeta_DP + 2 * object@omega_S * object@rho_DS * object@zeta_DS + 3 * object@omega_S * object@rho_SP * object@zeta_SP - 3 * object@rho_DP * object@z_PS * object@zeta**2 - 2 * object@rho_DS * object@z_SP * object@zeta**2)) + object@sigma_D * object@sigma_S * (2 * object@gamma * object@omega_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 2 * object@gamma * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@omega_S * object@cov_DS * object@zeta_DS + 2 * object@omega_S * object@demand@sigma**2 * object@zeta_DS + 2 * object@cov_DS * object@z_SP * object@zeta**2 - 2 * object@demand@sigma**2 * object@z_SP * object@zeta**2) + object@var_S * (-object@omega_S * object@rho_DP * object@demand@sigma**2 * object@zeta_DP - object@omega_S * object@rho_DS * object@demand@sigma**2 * object@zeta_DS + object@rho_DP * object@demand@sigma**2 * object@z_PS * object@zeta**2 + object@rho_DS * object@demand@sigma**2 * object@z_SP * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (object@sigma_P**3 * (-object@supply@alpha**2 * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@zeta**3) + object@sigma_P * (2 * object@gamma * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**3 - 3 * object@var_S * object@zeta**3 - object@supply@sigma**2 * object@zeta**3)) + object@zeta_DD**(5 / 2) * (object@sigma_P**3 * (object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@supply@alpha**2 * object@rho_SP**2 * object@zeta**3 - 2 * object@supply@alpha * object@delta * object@h_P * object@h_S * object@rho_SP * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@rho_SP**2 * object@zeta**3) + object@sigma_P * (-2 * object@gamma * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@gamma * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - 2 * object@h_P * object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**3 + object@h_P * object@h_S * object@rho_SP * object@supply@sigma**2 * object@zeta**3 + 2 * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta**3 - object@rho_SP**2 * object@supply@sigma**2 * object@zeta**3 + object@var_S * (3 * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - 3 * object@rho_SP**2 * object@zeta**3)) + object@sigma_S * (-2 * object@h_P * object@h_S * object@cov_SP * object@zeta**3 + 2 * object@rho_SP * object@cov_SP * object@zeta**3 + object@var_P * (-2 * object@demand@alpha * object@h_P * object@h_S * object@zeta**3 + 2 * object@demand@alpha * object@rho_SP * object@zeta**3 + 2 * object@gamma * object@h_P * object@h_S * object@zeta**3 - 2 * object@gamma * object@rho_SP * object@zeta**3))) + object@zeta_DD**3 * (2 * object@mu_P * object@var_S * object@z_PS * object@zeta**3 + object@sigma_P**3 * (object@supply@alpha**2 * object@h_S * object@z_SP * object@zeta**3 - 2 * object@supply@alpha * object@delta * object@h_S * object@z_SP * object@zeta**3) + object@sigma_P * (-2 * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 - 2 * object@h_S * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_SP * object@zeta**3 + object@h_S * object@supply@sigma**2 * object@z_SP * object@zeta**3 + object@var_S * (2 * object@h_P * object@z_PS * object@zeta**3 + object@h_S * object@z_SP * object@zeta**3) + object@sigma_S * (2 * object@demand@alpha * object@mu_P * object@z_SP * object@zeta**3 - 2 * object@gamma * object@mu_P * object@z_SP * object@zeta**3))) + object@zeta_DD**2 * (object@sigma_P**3 * (-object@supply@alpha**2 * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_SP * object@z_PS * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@h_S * object@rho_SP * object@z_PS * object@zeta**3) + object@sigma_P * (2 * object@gamma * object@h_P * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@gamma * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**3 + 2 * object@h_P * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_SP * object@zeta**3 - object@h_P * object@rho_SP * object@supply@sigma**2 * object@z_SP * object@zeta**3 + 2 * object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_PS * object@zeta**3 - object@h_S * object@rho_SP * object@supply@sigma**2 * object@z_PS * object@zeta**3 + object@var_S * (-3 * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - 3 * object@h_S * object@rho_SP * object@z_PS * object@zeta**3)) + object@sigma_S * (2 * object@h_P * object@cov_SP * object@z_SP * object@zeta**3 + 2 * object@h_S * object@cov_SP * object@z_PS * object@zeta**3 + object@var_P * (2 * object@demand@alpha * object@h_P * object@z_SP * object@zeta**3 + 2 * object@demand@alpha * object@h_S * object@z_PS * object@zeta**3 - 2 * object@gamma * object@h_P * object@z_SP * object@zeta**3 - 2 * object@gamma * object@h_S * object@z_PS * object@zeta**3)))))) / (2 * object@delta * object@var_D * object@sigma_P * object@var_S * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_other_controls", function(object) {
  standardGeneric("partial_other_controls")
})

setMethod("partial_other_controls", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  -object@supply@control_matrix * c(object@L_D * sqrt(object@zeta_DD) * (object@g_D * (-object@sigma_D * object@sigma_S * object@zeta_SP + object@sigma_P * (-object@demand@alpha * object@sigma_S * object@zeta_DS + object@sigma_D * object@zeta_SS * (object@demand@alpha - object@gamma))) + object@sigma_S * (object@demand@alpha * object@sigma_P * object@z_DP * object@zeta + object@sigma_D * object@z_PD * object@zeta)) + object@L_S * sqrt(object@zeta_SS) * (object@g_S * (-object@sigma_D * object@sigma_S * object@zeta_DP + object@sigma_P * (object@demand@alpha * object@sigma_S * object@zeta_DD + object@sigma_D * (-object@demand@alpha * object@zeta_DS + object@gamma * object@zeta_DS))) + object@sigma_D * (object@sigma_P * (object@demand@alpha * object@z_SP * object@zeta - object@gamma * object@z_SP * object@zeta) + object@sigma_S * object@z_PS * object@zeta))) / (object@delta * object@sigma_D * object@sigma_P * object@sigma_S * object@zeta * sqrt(object@zeta_DD) * sqrt(object@zeta_SS))
  # nolint end
})

setGeneric("partial_lagged_price", function(object) {
  standardGeneric("partial_lagged_price")
})

setMethod("partial_lagged_price", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  -(object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@zeta_SS**4 * (object@supply@alpha**2 * object@delta * object@h_S * object@sigma_P**4 * object@zeta**2 + object@var_P * (-2 * object@supply@alpha**2 * object@gamma * object@h_S * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@supply@alpha**2 * object@h_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@supply@alpha**2 * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + object@delta * object@h_S * object@var_S * object@zeta**2 - object@delta * object@h_S * object@supply@sigma**2 * object@zeta**2 + object@sigma_S * (-2 * object@lagged_price_vector * object@supply@alpha * object@delta * object@zeta**2 - 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@supply@alpha * object@delta * object@zeta**2 + 2 * object@supply@alpha * object@delta * object@mu_P * object@zeta**2))) + object@var_S * (object@zeta_SS**(5 / 2) * (object@demand@alpha**2 * object@delta * object@omega_D * object@rho_DP**2 * object@sigma_P**4 * object@zeta**2 + object@var_D * (-2 * object@gamma * object@omega_D * object@rho_DP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@omega_D * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@omega_D * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2) + object@sigma_D * (-2 * object@demand@alpha * object@delta * object@omega_D * object@rho_DP * object@sigma_P**3 * object@zeta**2 + object@sigma_P * (4 * object@demand@alpha * object@gamma * object@omega_D * object@rho_DP * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@demand@alpha * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@demand@alpha * object@omega_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@delta * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 2 * object@delta * object@omega_D * object@rho_DP * object@cov_DP * object@zeta**2)) + object@var_P * (-2 * object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@omega_D * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 3 * object@delta * object@omega_D * object@rho_DP**2 * object@var_D * object@zeta**2 - object@delta * object@omega_D * object@rho_DP**2 * object@demand@sigma**2 * object@zeta**2)) + object@zeta_SS**3 * (object@var_D * (-2 * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@price_equation@sigma**2 * object@zeta**2 + 2 * object@gamma * object@h_P * object@price_equation@sigma**2 * object@zeta**2 * object@zeta_SP + 4 * object@gamma * object@h_S * object@rho_DP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 * object@zeta_SP - 2 * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 * object@zeta_SP + 4 * object@h_S * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@h_S * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2) + object@sigma_D * object@sigma_P**3 * (-2 * object@demand@alpha * object@delta * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@h_P * object@rho_DS * object@zeta**2 + 4 * object@demand@alpha * object@delta * object@h_S * object@rho_DP * object@zeta**2) + object@sigma_P**4 * (object@demand@alpha**2 * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha**2 * object@delta * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha**2 * object@delta * object@h_S * object@rho_DP**2 * object@zeta**2) + object@var_P * (-2 * object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 + 2 * object@demand@alpha**2 * object@gamma * object@h_D * object@price_equation@sigma**2 * object@zeta**2 * object@zeta_DS - 2 * object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@demand@alpha**2 * object@gamma * object@h_S * object@rho_DP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 * object@zeta_DS - 2 * object@demand@alpha**2 * object@h_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 * object@zeta_DS - 2 * object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 4 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 4 * object@demand@alpha * object@delta * object@h_S * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - object@delta * object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma**2 * object@zeta**2 + object@delta * object@h_D * object@demand@sigma**2 * object@zeta**2 * object@zeta_DS - object@delta * object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma**2 * object@zeta**2 + 2 * object@delta * object@h_S * object@rho_DP**2 * object@demand@sigma**2 * object@zeta**2 + object@var_D * (3 * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@delta * object@h_D * object@zeta**2 * object@zeta_DS + 3 * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@delta * object@h_P * object@zeta**2 * object@zeta_SP - 6 * object@delta * object@h_S * object@rho_DP**2 * object@zeta**2) + object@sigma_D * (2 * object@lagged_price_vector * object@demand@alpha * object@delta * object@zeta**2 * object@zeta_DS + 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@demand@alpha * object@delta * object@zeta**2 * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@mu_P * object@zeta**2 * object@zeta_DS)) + object@sigma_P * (object@var_D * (2 * object@lagged_price_vector * object@delta * object@zeta**2 * object@zeta_SP + 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@delta * object@zeta**2 * object@zeta_SP - 2 * object@delta * object@mu_P * object@zeta**2 * object@zeta_SP) + object@sigma_D * (4 * object@demand@alpha * object@gamma * object@h_D * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@demand@alpha * object@gamma * object@h_P * object@rho_DS * object@price_equation@sigma**2 * object@zeta**2 - 8 * object@demand@alpha * object@gamma * object@h_S * object@rho_DP * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@demand@alpha * object@h_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@demand@alpha * object@h_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 4 * object@demand@alpha * object@h_P * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@demand@alpha * object@h_P * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 8 * object@demand@alpha * object@h_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 8 * object@demand@alpha * object@h_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@delta * object@h_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 2 * object@delta * object@h_D * object@rho_SP * object@cov_DP * object@zeta**2 + 2 * object@delta * object@h_P * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 2 * object@delta * object@h_P * object@rho_DS * object@cov_DP * object@zeta**2 - 4 * object@delta * object@h_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 4 * object@delta * object@h_S * object@rho_DP * object@cov_DP * object@zeta**2)))) + object@zeta_SS**(7 / 2) * (object@var_D * object@var_S * (-2 * object@gamma * object@omega_D * object@rho_DP * object@price_equation@sigma**2 * object@zeta_DP - 2 * object@gamma * object@omega_D * object@rho_SP * object@price_equation@sigma**2 * object@zeta_SP + 2 * object@gamma * object@rho_SP * object@price_equation@sigma**2 * object@z_PD * object@zeta**2 - 2 * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP + 2 * object@omega_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DP - 2 * object@omega_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_SP + 2 * object@omega_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**2 - 2 * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**2) + object@sigma_P**4 * (object@var_D * (object@supply@alpha**2 * object@delta * object@omega_D * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@delta * object@omega_D * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@delta * object@rho_DS * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@delta * object@rho_SP * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@delta * object@omega_D * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@delta * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@delta * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@delta * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@delta * object@rho_DS * object@z_DP * object@zeta**2)) + object@sigma_P**3 * (-2 * object@demand@alpha * object@delta * object@omega_D * object@sigma_D * object@var_S * object@zeta_DP + object@var_D * object@sigma_S * (-2 * object@supply@alpha * object@delta * object@omega_D * object@zeta_SP + 2 * object@supply@alpha * object@delta * object@z_PD * object@zeta**2)) + object@var_P * (object@var_D * (-2 * object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@price_equation@sigma**2 * object@zeta_DS - 2 * object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_SP * object@price_equation@sigma**2 * object@zeta_SP + 2 * object@supply@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma**2 * object@z_DP * object@zeta**2 + 2 * object@supply@alpha**2 * object@gamma * object@rho_SP * object@price_equation@sigma**2 * object@z_PD * object@zeta**2 - 2 * object@supply@alpha**2 * object@omega_D * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS + 2 * object@supply@alpha**2 * object@omega_D * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@supply@alpha**2 * object@omega_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_SP + 2 * object@supply@alpha**2 * object@omega_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@supply@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@supply@alpha**2 * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**2 + 2 * object@supply@alpha**2 * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**2 - 2 * object@supply@alpha**2 * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@omega_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@supply@alpha * object@delta * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**2 + 2 * object@supply@alpha * object@delta * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**2 - object@delta * object@omega_D * object@rho_DS * object@supply@sigma**2 * object@zeta_DS - object@delta * object@omega_D * object@rho_SP * object@supply@sigma**2 * object@zeta_SP + object@delta * object@rho_DS * object@supply@sigma**2 * object@z_DP * object@zeta**2 + object@delta * object@rho_SP * object@supply@sigma**2 * object@z_PD * object@zeta**2 + object@var_S * (3 * object@delta * object@omega_D * object@rho_DP * object@zeta_DP + 2 * object@delta * object@omega_D * object@rho_DS * object@zeta_DS + 3 * object@delta * object@omega_D * object@rho_SP * object@zeta_SP - 2 * object@delta * object@rho_DS * object@z_DP * object@zeta**2 - 3 * object@delta * object@rho_SP * object@z_PD * object@zeta**2)) + object@sigma_D * object@sigma_S * (4 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_D * object@price_equation@sigma**2 * object@zeta_DS - 4 * object@demand@alpha * object@supply@alpha * object@gamma * object@price_equation@sigma**2 * object@z_DP * object@zeta**2 + 4 * object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 4 * object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 4 * object@demand@alpha * object@supply@alpha * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**2 + 4 * object@demand@alpha * object@supply@alpha * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@omega_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**2 + 2 * object@supply@alpha * object@delta * object@omega_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**2 + 2 * object@delta * object@omega_D * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DS - 2 * object@delta * object@omega_D * object@cov_DS * object@zeta_DS - 2 * object@delta * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_DP * object@zeta**2 + 2 * object@delta * object@cov_DS * object@z_DP * object@zeta**2) + object@var_S * (-2 * object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP * object@price_equation@sigma**2 * object@zeta_DP - 2 * object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@price_equation@sigma**2 * object@zeta_DS + 2 * object@demand@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma**2 * object@z_DP * object@zeta**2 - 2 * object@demand@alpha**2 * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP + 2 * object@demand@alpha**2 * object@omega_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DP - 2 * object@demand@alpha**2 * object@omega_D * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha**2 * object@omega_D * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@demand@alpha**2 * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP - 2 * object@demand@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@delta * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**2 - object@delta * object@omega_D * object@rho_DP * object@demand@sigma**2 * object@zeta_DP - object@delta * object@omega_D * object@rho_DS * object@demand@sigma**2 * object@zeta_DS + object@delta * object@rho_DS * object@demand@sigma**2 * object@z_DP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (4 * object@supply@alpha * object@gamma * object@omega_D * object@price_equation@sigma**2 * object@zeta_SP - 4 * object@supply@alpha * object@gamma * object@price_equation@sigma**2 * object@z_PD * object@zeta**2 + 4 * object@supply@alpha * object@omega_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_SP - 4 * object@supply@alpha * object@omega_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP - 4 * object@supply@alpha * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**2 + 4 * object@supply@alpha * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**2 + 2 * object@delta * object@omega_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP - 2 * object@delta * object@omega_D * object@cov_SP * object@zeta_SP - 2 * object@delta * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**2 + 2 * object@delta * object@cov_SP * object@z_PD * object@zeta**2) + object@sigma_D * object@var_S * (4 * object@demand@alpha * object@gamma * object@omega_D * object@price_equation@sigma**2 * object@zeta_DP + 4 * object@demand@alpha * object@omega_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP - 4 * object@demand@alpha * object@omega_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DP + 2 * object@delta * object@omega_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP - 2 * object@delta * object@omega_D * object@cov_DP * object@zeta_DP)))) + object@var_S * (object@zeta_SS**(7 / 2) * (-object@demand@alpha**2 * object@delta * object@sigma_P**4 * object@zeta**3 + object@var_D * (2 * object@gamma * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3) + object@var_P * (2 * object@demand@alpha**2 * object@gamma * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@demand@alpha**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@demand@alpha**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 3 * object@delta * object@var_D * object@zeta**3 + object@delta * object@demand@sigma**2 * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@var_D * (-2 * object@gamma * object@h_D * object@h_P * object@rho_DP * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@gamma * object@rho_DP**2 * object@price_equation@sigma**2 * object@zeta**3 - 2 * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 2 * object@h_D * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3) + object@sigma_D * (object@sigma_P**3 * (-2 * object@demand@alpha * object@delta * object@h_D * object@h_P * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@rho_DP * object@zeta**3) + object@sigma_P * (4 * object@demand@alpha * object@gamma * object@h_D * object@h_P * object@price_equation@sigma**2 * object@zeta**3 - 4 * object@demand@alpha * object@gamma * object@rho_DP * object@price_equation@sigma**2 * object@zeta**3 + 4 * object@demand@alpha * object@h_D * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 4 * object@demand@alpha * object@h_D * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - 4 * object@demand@alpha * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 4 * object@demand@alpha * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@delta * object@h_D * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@delta * object@h_D * object@h_P * object@cov_DP * object@zeta**3 - 2 * object@delta * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 2 * object@delta * object@rho_DP * object@cov_DP * object@zeta**3)) + object@sigma_P**4 * (object@demand@alpha**2 * object@delta * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha**2 * object@delta * object@rho_DP**2 * object@zeta**3) + object@var_P * (-2 * object@demand@alpha**2 * object@gamma * object@h_D * object@h_P * object@rho_DP * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@demand@alpha**2 * object@gamma * object@rho_DP**2 * object@price_equation@sigma**2 * object@zeta**3 - 2 * object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 2 * object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@demand@alpha**2 * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@demand@alpha**2 * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - 2 * object@demand@alpha * object@delta * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - object@delta * object@h_D * object@h_P * object@rho_DP * object@demand@sigma**2 * object@zeta**3 + object@delta * object@rho_DP**2 * object@demand@sigma**2 * object@zeta**3 + object@var_D * (3 * object@delta * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - 3 * object@delta * object@rho_DP**2 * object@zeta**3))) + object@zeta_SS**3 * (object@demand@alpha**2 * object@delta * object@h_D * object@sigma_P**4 * object@z_DP * object@zeta**3 + object@var_D * (-2 * object@gamma * object@h_P * object@price_equation@sigma**2 * object@z_PD * object@zeta**3 - 2 * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**3 + 2 * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**3 + object@sigma_P * (-2 * object@lagged_price_vector * object@delta * object@z_PD * object@zeta**3 - 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@delta * object@z_PD * object@zeta**3 + 2 * object@delta * object@mu_P * object@z_PD * object@zeta**3)) + object@var_P * (-2 * object@demand@alpha**2 * object@gamma * object@h_D * object@price_equation@sigma**2 * object@z_DP * object@zeta**3 - 2 * object@demand@alpha**2 * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 + 2 * object@demand@alpha**2 * object@h_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**3 - 2 * object@demand@alpha * object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@delta * object@h_D * object@demand@sigma**2 * object@z_DP * object@zeta**3 + object@var_D * (object@delta * object@h_D * object@z_DP * object@zeta**3 + 2 * object@delta * object@h_P * object@z_PD * object@zeta**3) + object@sigma_D * (-2 * object@lagged_price_vector * object@demand@alpha * object@delta * object@z_DP * object@zeta**3 - 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@demand@alpha * object@delta * object@z_DP * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@mu_P * object@z_DP * object@zeta**3))) + object@zeta_SS**2 * (object@var_D * (2 * object@gamma * object@h_D * object@rho_DP * object@price_equation@sigma**2 * object@z_PD * object@zeta**3 + 2 * object@gamma * object@h_P * object@rho_DP * object@price_equation@sigma**2 * object@z_DP * object@zeta**3 + 2 * object@h_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**3 - 2 * object@h_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**3 + 2 * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 - 2 * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**3) + object@sigma_D * (object@sigma_P**3 * (2 * object@demand@alpha * object@delta * object@h_D * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@h_P * object@z_DP * object@zeta**3) + object@sigma_P * (-4 * object@demand@alpha * object@gamma * object@h_D * object@price_equation@sigma**2 * object@z_PD * object@zeta**3 - 4 * object@demand@alpha * object@gamma * object@h_P * object@price_equation@sigma**2 * object@z_DP * object@zeta**3 - 4 * object@demand@alpha * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**3 + 4 * object@demand@alpha * object@h_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**3 - 4 * object@demand@alpha * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 + 4 * object@demand@alpha * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**3 - 2 * object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**3 + 2 * object@delta * object@h_D * object@cov_DP * object@z_PD * object@zeta**3 - 2 * object@delta * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 + 2 * object@delta * object@h_P * object@cov_DP * object@z_DP * object@zeta**3)) + object@sigma_P**4 * (-object@demand@alpha**2 * object@delta * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@delta * object@h_P * object@rho_DP * object@z_DP * object@zeta**3) + object@var_P * (2 * object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@price_equation@sigma**2 * object@z_PD * object@zeta**3 + 2 * object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@price_equation@sigma**2 * object@z_DP * object@zeta**3 + 2 * object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**3 - 2 * object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PD * object@zeta**3 + 2 * object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 - 2 * object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_DP * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_DP * object@zeta**3 + object@delta * object@h_D * object@rho_DP * object@demand@sigma**2 * object@z_PD * object@zeta**3 + object@delta * object@h_P * object@rho_DP * object@demand@sigma**2 * object@z_DP * object@zeta**3 + object@var_D * (-3 * object@delta * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - 3 * object@delta * object@h_P * object@rho_DP * object@z_DP * object@zeta**3))))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@supply@alpha**2 * object@delta * object@omega_S * object@rho_SP**2 * object@sigma_P**4 * object@zeta**2 + object@var_P * (-2 * object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_S * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 3 * object@delta * object@omega_S * object@rho_SP**2 * object@var_S * object@zeta**2 - object@delta * object@omega_S * object@rho_SP**2 * object@supply@sigma**2 * object@zeta**2) + object@var_S * (-2 * object@gamma * object@omega_S * object@rho_SP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@omega_S * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@omega_S * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2) + object@sigma_S * (-2 * object@supply@alpha * object@delta * object@omega_S * object@rho_SP * object@sigma_P**3 * object@zeta**2 + object@sigma_P * (4 * object@supply@alpha * object@gamma * object@omega_S * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@supply@alpha * object@omega_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@supply@alpha * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@delta * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@delta * object@omega_S * object@rho_SP * object@cov_SP * object@zeta**2))) + object@zeta_DD**3 * (object@sigma_P**4 * (-2 * object@supply@alpha**2 * object@delta * object@h_D * object@rho_SP**2 * object@zeta**2 + object@supply@alpha**2 * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 + object@supply@alpha**2 * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@supply@alpha**2 * object@delta * object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_P**3 * object@sigma_S * (4 * object@supply@alpha * object@delta * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_P * object@rho_DS * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_S * object@rho_DP * object@zeta**2) + object@var_P * (4 * object@supply@alpha**2 * object@gamma * object@h_D * object@rho_SP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@supply@alpha**2 * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@supply@alpha**2 * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 + 2 * object@supply@alpha**2 * object@gamma * object@h_S * object@price_equation@sigma**2 * object@zeta**2 * object@zeta_DS + 4 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@supply@alpha**2 * object@h_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 * object@zeta_DS - 2 * object@supply@alpha**2 * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 * object@zeta_DS + 4 * object@supply@alpha * object@delta * object@h_D * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@supply@alpha * object@delta * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 * object@zeta_DS + 2 * object@delta * object@h_D * object@rho_SP**2 * object@supply@sigma**2 * object@zeta**2 - object@delta * object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma**2 * object@zeta**2 - object@delta * object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma**2 * object@zeta**2 + object@delta * object@h_S * object@supply@sigma**2 * object@zeta**2 * object@zeta_DS + object@var_S * (-6 * object@delta * object@h_D * object@rho_SP**2 * object@zeta**2 + 3 * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - 2 * object@delta * object@h_P * object@zeta**2 * object@zeta_DP + 3 * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@delta * object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_S * (2 * object@lagged_price_vector * object@supply@alpha * object@delta * object@zeta**2 * object@zeta_DS + 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@supply@alpha * object@delta * object@zeta**2 * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@mu_P * object@zeta**2 * object@zeta_DS)) + object@sigma_P * (object@var_S * (2 * object@lagged_price_vector * object@delta * object@zeta**2 * object@zeta_DP + 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@delta * object@zeta**2 * object@zeta_DP - 2 * object@delta * object@mu_P * object@zeta**2 * object@zeta_DP) + object@sigma_S * (-8 * object@supply@alpha * object@gamma * object@h_D * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@supply@alpha * object@gamma * object@h_P * object@rho_DS * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@supply@alpha * object@gamma * object@h_S * object@rho_DP * object@price_equation@sigma**2 * object@zeta**2 - 8 * object@supply@alpha * object@h_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 8 * object@supply@alpha * object@h_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 4 * object@supply@alpha * object@h_P * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@supply@alpha * object@h_P * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 4 * object@supply@alpha * object@h_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@supply@alpha * object@h_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 4 * object@delta * object@h_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 4 * object@delta * object@h_D * object@rho_SP * object@cov_SP * object@zeta**2 + 2 * object@delta * object@h_P * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@delta * object@h_P * object@rho_DS * object@cov_SP * object@zeta**2 + 2 * object@delta * object@h_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@delta * object@h_S * object@rho_DP * object@cov_SP * object@zeta**2)) + object@var_S * (4 * object@gamma * object@h_D * object@rho_SP**2 * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 + 2 * object@gamma * object@h_P * object@price_equation@sigma**2 * object@zeta**2 * object@zeta_DP - 2 * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@price_equation@sigma**2 * object@zeta**2 + 4 * object@h_D * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 - 4 * object@h_D * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 + 2 * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 * object@zeta_DP - 2 * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 * object@zeta_DP - 2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2))) + object@var_S * object@zeta_DD**4 * (object@demand@alpha**2 * object@delta * object@h_D * object@sigma_P**4 * object@zeta**2 + object@var_P * (-2 * object@demand@alpha**2 * object@gamma * object@h_D * object@price_equation@sigma**2 * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@h_D * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**2 + object@delta * object@h_D * object@var_D * object@zeta**2 - object@delta * object@h_D * object@demand@sigma**2 * object@zeta**2 + object@sigma_D * (-2 * object@lagged_price_vector * object@demand@alpha * object@delta * object@zeta**2 - 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@demand@alpha * object@delta * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@mu_P * object@zeta**2))) + object@zeta_DD**(7 / 2) * (object@var_D * object@var_S * (-2 * object@gamma * object@omega_S * object@rho_DP * object@price_equation@sigma**2 * object@zeta_DP - 2 * object@gamma * object@omega_S * object@rho_SP * object@price_equation@sigma**2 * object@zeta_SP + 2 * object@gamma * object@rho_DP * object@price_equation@sigma**2 * object@z_PS * object@zeta**2 - 2 * object@omega_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP + 2 * object@omega_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DP - 2 * object@omega_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_SP + 2 * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**2 - 2 * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**2) + object@sigma_P**4 * (object@var_D * (object@supply@alpha**2 * object@delta * object@omega_S * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@delta * object@omega_S * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@delta * object@rho_DS * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@delta * object@omega_S * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@delta * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@delta * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@delta * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@delta * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@delta * object@rho_DS * object@z_SP * object@zeta**2)) + object@sigma_P**3 * (-2 * object@supply@alpha * object@delta * object@omega_S * object@var_D * object@sigma_S * object@zeta_SP + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@delta * object@omega_S * object@zeta_DP + 2 * object@demand@alpha * object@delta * object@z_PS * object@zeta**2)) + object@var_P * (object@var_D * (-2 * object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@price_equation@sigma**2 * object@zeta_DS - 2 * object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP * object@price_equation@sigma**2 * object@zeta_SP + 2 * object@supply@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma**2 * object@z_SP * object@zeta**2 - 2 * object@supply@alpha**2 * object@omega_S * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS + 2 * object@supply@alpha**2 * object@omega_S * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@supply@alpha**2 * object@omega_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_SP + 2 * object@supply@alpha**2 * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@supply@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@supply@alpha**2 * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@supply@alpha * object@delta * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**2 - object@delta * object@omega_S * object@rho_DS * object@supply@sigma**2 * object@zeta_DS - object@delta * object@omega_S * object@rho_SP * object@supply@sigma**2 * object@zeta_SP + object@delta * object@rho_DS * object@supply@sigma**2 * object@z_SP * object@zeta**2 + object@var_S * (3 * object@delta * object@omega_S * object@rho_DP * object@zeta_DP + 2 * object@delta * object@omega_S * object@rho_DS * object@zeta_DS + 3 * object@delta * object@omega_S * object@rho_SP * object@zeta_SP - 3 * object@delta * object@rho_DP * object@z_PS * object@zeta**2 - 2 * object@delta * object@rho_DS * object@z_SP * object@zeta**2)) + object@sigma_D * object@sigma_S * (4 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_S * object@price_equation@sigma**2 * object@zeta_DS - 4 * object@demand@alpha * object@supply@alpha * object@gamma * object@price_equation@sigma**2 * object@z_SP * object@zeta**2 + 4 * object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 4 * object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 4 * object@demand@alpha * object@supply@alpha * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**2 + 4 * object@demand@alpha * object@supply@alpha * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@omega_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS - 2 * object@demand@alpha * object@delta * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**2 + 2 * object@supply@alpha * object@delta * object@omega_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**2 + 2 * object@delta * object@omega_S * object@rho_ds * object@demand@sigma * object@supply@sigma * object@zeta_DS - 2 * object@delta * object@omega_S * object@cov_DS * object@zeta_DS - 2 * object@delta * object@rho_ds * object@demand@sigma * object@supply@sigma * object@z_SP * object@zeta**2 + 2 * object@delta * object@cov_DS * object@z_SP * object@zeta**2) + object@var_S * (-2 * object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DP * object@price_equation@sigma**2 * object@zeta_DP - 2 * object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@price_equation@sigma**2 * object@zeta_DS + 2 * object@demand@alpha**2 * object@gamma * object@rho_DP * object@price_equation@sigma**2 * object@z_PS * object@zeta**2 + 2 * object@demand@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma**2 * object@z_SP * object@zeta**2 - 2 * object@demand@alpha**2 * object@omega_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP + 2 * object@demand@alpha**2 * object@omega_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DP - 2 * object@demand@alpha**2 * object@omega_S * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha**2 * object@omega_S * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha**2 * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**2 - 2 * object@demand@alpha**2 * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**2 + 2 * object@demand@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@demand@alpha**2 * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@omega_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP - 2 * object@demand@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@delta * object@rho_DP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@rho_DS * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**2 - object@delta * object@omega_S * object@rho_DP * object@demand@sigma**2 * object@zeta_DP - object@delta * object@omega_S * object@rho_DS * object@demand@sigma**2 * object@zeta_DS + object@delta * object@rho_DP * object@demand@sigma**2 * object@z_PS * object@zeta**2 + object@delta * object@rho_DS * object@demand@sigma**2 * object@z_SP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (4 * object@supply@alpha * object@gamma * object@omega_S * object@price_equation@sigma**2 * object@zeta_SP + 4 * object@supply@alpha * object@omega_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_SP - 4 * object@supply@alpha * object@omega_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP + 2 * object@delta * object@omega_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_SP - 2 * object@delta * object@omega_S * object@cov_SP * object@zeta_SP) + object@sigma_D * object@var_S * (4 * object@demand@alpha * object@gamma * object@omega_S * object@price_equation@sigma**2 * object@zeta_DP - 4 * object@demand@alpha * object@gamma * object@price_equation@sigma**2 * object@z_PS * object@zeta**2 + 4 * object@demand@alpha * object@omega_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP - 4 * object@demand@alpha * object@omega_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta_DP - 4 * object@demand@alpha * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**2 + 4 * object@demand@alpha * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**2 + 2 * object@delta * object@omega_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta_DP - 2 * object@delta * object@omega_S * object@cov_DP * object@zeta_DP - 2 * object@delta * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**2 + 2 * object@delta * object@cov_DP * object@z_PS * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (-object@supply@alpha**2 * object@delta * object@sigma_P**4 * object@zeta**3 + object@var_P * (2 * object@supply@alpha**2 * object@gamma * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@supply@alpha**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@supply@alpha**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - 3 * object@delta * object@var_S * object@zeta**3 + object@delta * object@supply@sigma**2 * object@zeta**3) + object@var_S * (2 * object@gamma * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3)) + object@zeta_DD**(5 / 2) * (object@sigma_P**4 * (object@supply@alpha**2 * object@delta * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@supply@alpha**2 * object@delta * object@rho_SP**2 * object@zeta**3) + object@var_P * (-2 * object@supply@alpha**2 * object@gamma * object@h_P * object@h_S * object@rho_SP * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@supply@alpha**2 * object@gamma * object@rho_SP**2 * object@price_equation@sigma**2 * object@zeta**3 - 2 * object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 2 * object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@supply@alpha**2 * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@supply@alpha**2 * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - 2 * object@supply@alpha * object@delta * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - object@delta * object@h_P * object@h_S * object@rho_SP * object@supply@sigma**2 * object@zeta**3 + object@delta * object@rho_SP**2 * object@supply@sigma**2 * object@zeta**3 + object@var_S * (3 * object@delta * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - 3 * object@delta * object@rho_SP**2 * object@zeta**3)) + object@var_S * (-2 * object@gamma * object@h_P * object@h_S * object@rho_SP * object@price_equation@sigma**2 * object@zeta**3 + 2 * object@gamma * object@rho_SP**2 * object@price_equation@sigma**2 * object@zeta**3 - 2 * object@h_P * object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 2 * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 2 * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3) + object@sigma_S * (object@sigma_P**3 * (-2 * object@supply@alpha * object@delta * object@h_P * object@h_S * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@rho_SP * object@zeta**3) + object@sigma_P * (4 * object@supply@alpha * object@gamma * object@h_P * object@h_S * object@price_equation@sigma**2 * object@zeta**3 - 4 * object@supply@alpha * object@gamma * object@rho_SP * object@price_equation@sigma**2 * object@zeta**3 + 4 * object@supply@alpha * object@h_P * object@h_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 - 4 * object@supply@alpha * object@h_P * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - 4 * object@supply@alpha * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@zeta**3 + 4 * object@supply@alpha * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@delta * object@h_P * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 - 2 * object@delta * object@h_P * object@h_S * object@cov_SP * object@zeta**3 - 2 * object@delta * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@zeta**3 + 2 * object@delta * object@rho_SP * object@cov_SP * object@zeta**3))) + object@zeta_DD**3 * (object@supply@alpha**2 * object@delta * object@h_S * object@sigma_P**4 * object@z_SP * object@zeta**3 + object@var_P * (-2 * object@supply@alpha**2 * object@gamma * object@h_S * object@price_equation@sigma**2 * object@z_SP * object@zeta**3 - 2 * object@supply@alpha**2 * object@h_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha**2 * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 - 2 * object@supply@alpha * object@delta * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 - object@delta * object@h_S * object@supply@sigma**2 * object@z_SP * object@zeta**3 + object@var_S * (2 * object@delta * object@h_P * object@z_PS * object@zeta**3 + object@delta * object@h_S * object@z_SP * object@zeta**3) + object@sigma_S * (-2 * object@lagged_price_vector * object@supply@alpha * object@delta * object@z_SP * object@zeta**3 - 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@supply@alpha * object@delta * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@mu_P * object@z_SP * object@zeta**3)) + object@var_S * (-2 * object@gamma * object@h_P * object@price_equation@sigma**2 * object@z_PS * object@zeta**3 - 2 * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**3 + 2 * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**3 + object@sigma_P * (-2 * object@lagged_price_vector * object@delta * object@z_PS * object@zeta**3 - 2 * object@price_equation@control_matrix %*% object@price_equation@beta * object@delta * object@z_PS * object@zeta**3 + 2 * object@delta * object@mu_P * object@z_PS * object@zeta**3))) + object@zeta_DD**2 * (object@sigma_P**4 * (-object@supply@alpha**2 * object@delta * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@delta * object@h_S * object@rho_SP * object@z_PS * object@zeta**3) + object@var_P * (2 * object@supply@alpha**2 * object@gamma * object@h_P * object@rho_SP * object@price_equation@sigma**2 * object@z_SP * object@zeta**3 + 2 * object@supply@alpha**2 * object@gamma * object@h_S * object@rho_SP * object@price_equation@sigma**2 * object@z_PS * object@zeta**3 + 2 * object@supply@alpha**2 * object@h_P * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**3 - 2 * object@supply@alpha**2 * object@h_P * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha**2 * object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**3 - 2 * object@supply@alpha**2 * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@h_P * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**3 + object@delta * object@h_P * object@rho_SP * object@supply@sigma**2 * object@z_SP * object@zeta**3 + object@delta * object@h_S * object@rho_SP * object@supply@sigma**2 * object@z_PS * object@zeta**3 + object@var_S * (-3 * object@delta * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - 3 * object@delta * object@h_S * object@rho_SP * object@z_PS * object@zeta**3)) + object@var_S * (2 * object@gamma * object@h_P * object@rho_SP * object@price_equation@sigma**2 * object@z_SP * object@zeta**3 + 2 * object@gamma * object@h_S * object@rho_SP * object@price_equation@sigma**2 * object@z_PS * object@zeta**3 + 2 * object@h_P * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**3 - 2 * object@h_P * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**3 - 2 * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**3) + object@sigma_S * (object@sigma_P**3 * (2 * object@supply@alpha * object@delta * object@h_P * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@delta * object@h_S * object@z_PS * object@zeta**3) + object@sigma_P * (-4 * object@supply@alpha * object@gamma * object@h_P * object@price_equation@sigma**2 * object@z_SP * object@zeta**3 - 4 * object@supply@alpha * object@gamma * object@h_S * object@price_equation@sigma**2 * object@z_PS * object@zeta**3 - 4 * object@supply@alpha * object@h_P * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_SP * object@zeta**3 + 4 * object@supply@alpha * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 - 4 * object@supply@alpha * object@h_S * object@rho_dp * object@demand@sigma * object@price_equation@sigma * object@z_PS * object@zeta**3 + 4 * object@supply@alpha * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**3 - 2 * object@delta * object@h_P * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@delta * object@h_P * object@cov_SP * object@z_SP * object@zeta**3 - 2 * object@delta * object@h_S * object@rho_sp * object@price_equation@sigma * object@supply@sigma * object@z_PS * object@zeta**3 + 2 * object@delta * object@h_S * object@cov_SP * object@z_PS * object@zeta**3)))))) / (2 * object@delta**2 * object@var_D * object@var_P * object@var_S * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_price_controls", function(object) {
  standardGeneric("partial_price_controls")
})

setMethod("partial_price_controls", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  -object@gamma * object@price_equation@control_matrix * c(object@L_D * sqrt(object@zeta_DD) * (object@g_D * (object@sigma_D * object@sigma_S * object@zeta_SP + object@sigma_P * (object@demand@alpha * object@sigma_S * object@zeta_DS - object@supply@alpha * object@sigma_D * object@zeta_SS)) + object@sigma_S * (-object@demand@alpha * object@sigma_P * object@z_DP * object@zeta - object@sigma_D * object@z_PD * object@zeta)) + object@L_S * sqrt(object@zeta_SS) * (object@g_S * (object@sigma_D * object@sigma_S * object@zeta_DP + object@sigma_P * (-object@demand@alpha * object@sigma_S * object@zeta_DD + object@supply@alpha * object@sigma_D * object@zeta_DS)) + object@sigma_D * (-object@supply@alpha * object@sigma_P * object@z_SP * object@zeta - object@sigma_S * object@z_PS * object@zeta))) / (object@delta * object@sigma_D * object@sigma_P * object@sigma_S * object@zeta * sqrt(object@zeta_DD) * sqrt(object@zeta_SS))
  # nolint end
})

setGeneric("partial_own_variance", function(object) {
  standardGeneric("partial_own_variance")
})

setMethod("partial_own_variance", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  (object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@var_P * object@zeta_SS**4 * (object@supply@alpha**2 * object@gamma * object@h_S * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@rho_ds * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_S * object@rho_ds * object@supply@sigma * object@zeta**2) + object@var_S * (object@zeta_SS**(5 / 2) * (object@var_D * (object@gamma * object@omega_D * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@omega_D * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 + object@omega_D * object@rho_DP**2 * object@demand@sigma * object@zeta**2) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@omega_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + 2 * object@demand@alpha * object@omega_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@omega_D * object@rho_DP * object@demand@sigma * object@zeta**2 - object@delta * object@gamma * object@omega_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + object@delta * object@omega_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@gamma * object@omega_D * object@rho_DP * object@demand@sigma * object@zeta**2) + object@var_P * (object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@demand@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@gamma * object@omega_D * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha * object@delta * object@omega_D * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@omega_D * object@rho_DP**2 * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@omega_D * object@rho_DP**2 * object@demand@sigma * object@zeta**2 + object@delta * object@gamma * object@omega_D * object@rho_DP**2 * object@demand@sigma * object@zeta**2)) + object@zeta_SS**3 * (object@var_D * (object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@gamma * object@h_P * object@rho_dp * object@price_equation@sigma * object@zeta**2 * object@zeta_SP - 2 * object@gamma * object@h_S * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@h_D * object@rho_DP * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma * object@zeta**2 - object@h_P * object@rho_DP * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma * object@zeta**2 + object@h_P * object@rho_ds * object@supply@sigma * object@zeta**2 * object@zeta_SP - object@h_P * object@demand@sigma * object@zeta**2 * object@zeta_SP + 2 * object@h_S * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@h_S * object@rho_DP**2 * object@demand@sigma * object@zeta**2) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@h_D * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@gamma * object@h_P * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta**2 + 4 * object@demand@alpha * object@gamma * object@h_S * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_D * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_P * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta**2 - 4 * object@demand@alpha * object@h_S * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_D * object@rho_SP * object@demand@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_P * object@rho_DS * object@demand@sigma * object@zeta**2 + 4 * object@supply@alpha * object@h_S * object@rho_DP * object@demand@sigma * object@zeta**2 - object@delta * object@gamma * object@h_D * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@delta * object@gamma * object@h_P * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta**2 + 2 * object@delta * object@gamma * object@h_S * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + object@delta * object@h_D * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@delta * object@h_P * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@delta * object@h_S * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@gamma * object@h_D * object@rho_SP * object@demand@sigma * object@zeta**2 - 2 * object@gamma * object@h_P * object@rho_DS * object@demand@sigma * object@zeta**2 + 4 * object@gamma * object@h_S * object@rho_DP * object@demand@sigma * object@zeta**2) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha**2 * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha**2 * object@gamma * object@h_S * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_D * object@rho_ds * object@supply@sigma * object@zeta**2 * object@zeta_DS - object@demand@alpha**2 * object@h_D * object@demand@sigma * object@zeta**2 * object@zeta_DS - object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@demand@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha * object@delta * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha * object@delta * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@gamma * object@h_S * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_D * object@rho_ds * object@supply@sigma * object@zeta**2 * object@zeta_DS - object@demand@alpha * object@delta * object@h_D * object@demand@sigma * object@zeta**2 * object@zeta_DS - object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha * object@delta * object@h_S * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@h_S * object@rho_DP**2 * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@h_D * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@supply@alpha * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_S * object@rho_DP**2 * object@demand@sigma * object@zeta**2 + object@delta * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@demand@sigma * object@zeta**2 - object@delta * object@gamma * object@h_D * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@delta * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@demand@sigma * object@zeta**2 - 2 * object@delta * object@gamma * object@h_S * object@rho_DP**2 * object@demand@sigma * object@zeta**2))) + object@zeta_SS**(7 / 2) * (object@var_D * object@var_S * (object@gamma * object@omega_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@gamma * object@omega_D * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta_SP - object@gamma * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**2 - object@omega_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta_DP + object@omega_D * object@rho_DP * object@demand@sigma * object@zeta_DP - object@omega_D * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta_SP + object@omega_D * object@rho_SP * object@demand@sigma * object@zeta_SP + object@rho_SP * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**2 - object@rho_SP * object@demand@sigma * object@z_PD * object@zeta**2) + object@var_P * (object@var_D * (object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta_DS + object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta_SP - object@supply@alpha**2 * object@gamma * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@gamma * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**2 - object@supply@alpha**2 * object@omega_D * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@supply@alpha**2 * object@omega_D * object@rho_DS * object@demand@sigma * object@zeta_DS - object@supply@alpha**2 * object@omega_D * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta_SP + object@supply@alpha**2 * object@omega_D * object@rho_SP * object@demand@sigma * object@zeta_SP + object@supply@alpha**2 * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@rho_DS * object@demand@sigma * object@z_DP * object@zeta**2 + object@supply@alpha**2 * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**2 - object@supply@alpha**2 * object@rho_SP * object@demand@sigma * object@z_PD * object@zeta**2 + object@supply@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@omega_D * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta_SP - object@supply@alpha * object@delta * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**2 - object@supply@alpha * object@delta * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_D * object@rho_dp * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@gamma * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**2 + 2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_ds * object@supply@sigma * object@zeta_DS - 2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@demand@sigma * object@zeta_DS - 2 * object@demand@alpha * object@supply@alpha * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**2 + 2 * object@demand@alpha * object@supply@alpha * object@demand@sigma * object@z_DP * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@omega_D * object@rho_dp * object@price_equation@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@gamma * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_D * object@demand@sigma * object@zeta_DS + 2 * object@supply@alpha * object@delta * object@demand@sigma * object@z_DP * object@zeta**2 - object@delta * object@gamma * object@omega_D * object@rho_ds * object@supply@sigma * object@zeta_DS + object@delta * object@gamma * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha**2 * object@gamma * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**2 - object@demand@alpha**2 * object@omega_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta_DP + object@demand@alpha**2 * object@omega_D * object@rho_DP * object@demand@sigma * object@zeta_DP - object@demand@alpha**2 * object@omega_D * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@demand@alpha**2 * object@omega_D * object@rho_DS * object@demand@sigma * object@zeta_DS + object@demand@alpha**2 * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**2 - object@demand@alpha**2 * object@rho_DS * object@demand@sigma * object@z_DP * object@zeta**2 + object@demand@alpha * object@delta * object@gamma * object@omega_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@gamma * object@omega_D * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@gamma * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**2 - object@demand@alpha * object@delta * object@omega_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@omega_D * object@rho_DP * object@demand@sigma * object@zeta_DP - object@demand@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@omega_D * object@rho_DS * object@demand@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**2 - object@demand@alpha * object@delta * object@rho_DS * object@demand@sigma * object@z_DP * object@zeta**2 + object@supply@alpha * object@delta * object@omega_D * object@rho_DP * object@demand@sigma * object@zeta_DP + object@supply@alpha * object@delta * object@omega_D * object@rho_DS * object@demand@sigma * object@zeta_DS - object@supply@alpha * object@delta * object@rho_DS * object@demand@sigma * object@z_DP * object@zeta**2 + object@delta * object@gamma * object@omega_D * object@rho_DP * object@demand@sigma * object@zeta_DP + object@delta * object@gamma * object@omega_D * object@rho_DS * object@demand@sigma * object@zeta_DS - object@delta * object@gamma * object@rho_DS * object@demand@sigma * object@z_DP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@omega_D * object@rho_dp * object@price_equation@sigma * object@zeta_SP + 2 * object@supply@alpha * object@gamma * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**2 + 2 * object@supply@alpha * object@omega_D * object@rho_ds * object@supply@sigma * object@zeta_SP - 2 * object@supply@alpha * object@omega_D * object@demand@sigma * object@zeta_SP - 2 * object@supply@alpha * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**2 + 2 * object@supply@alpha * object@demand@sigma * object@z_PD * object@zeta**2 - object@delta * object@omega_D * object@rho_ds * object@supply@sigma * object@zeta_SP + object@delta * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**2) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@gamma * object@omega_D * object@rho_dp * object@price_equation@sigma * object@zeta_DP + 2 * object@demand@alpha * object@omega_D * object@rho_ds * object@supply@sigma * object@zeta_DP - 2 * object@supply@alpha * object@omega_D * object@demand@sigma * object@zeta_DP - object@delta * object@gamma * object@omega_D * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@delta * object@omega_D * object@rho_ds * object@supply@sigma * object@zeta_DP - 2 * object@gamma * object@omega_D * object@demand@sigma * object@zeta_DP)))) + object@var_S * (object@zeta_SS**(7 / 2) * (object@var_D * (-object@gamma * object@rho_dp * object@price_equation@sigma * object@zeta**3 + object@rho_ds * object@supply@sigma * object@zeta**3 - object@demand@sigma * object@zeta**3) + object@var_P * (-object@demand@alpha**2 * object@gamma * object@rho_dp * object@price_equation@sigma * object@zeta**3 + object@demand@alpha**2 * object@rho_ds * object@supply@sigma * object@zeta**3 - object@demand@alpha**2 * object@demand@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@gamma * object@rho_dp * object@price_equation@sigma * object@zeta**3 + object@demand@alpha * object@delta * object@rho_ds * object@supply@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@demand@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@demand@sigma * object@zeta**3 - object@delta * object@gamma * object@demand@sigma * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@var_D * (object@gamma * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@gamma * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@h_D * object@h_P * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**3 + object@h_D * object@h_P * object@rho_DP * object@demand@sigma * object@zeta**3 + object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**3 - object@rho_DP**2 * object@demand@sigma * object@zeta**3) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@h_D * object@h_P * object@rho_dp * object@price_equation@sigma * object@zeta**3 + 2 * object@demand@alpha * object@gamma * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**3 + 2 * object@demand@alpha * object@h_D * object@h_P * object@rho_ds * object@supply@sigma * object@zeta**3 - 2 * object@demand@alpha * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**3 - 2 * object@supply@alpha * object@h_D * object@h_P * object@demand@sigma * object@zeta**3 + 2 * object@supply@alpha * object@rho_DP * object@demand@sigma * object@zeta**3 - object@delta * object@gamma * object@h_D * object@h_P * object@rho_dp * object@price_equation@sigma * object@zeta**3 + object@delta * object@gamma * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**3 + object@delta * object@h_D * object@h_P * object@rho_ds * object@supply@sigma * object@zeta**3 - object@delta * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**3 - 2 * object@gamma * object@h_D * object@h_P * object@demand@sigma * object@zeta**3 + 2 * object@gamma * object@rho_DP * object@demand@sigma * object@zeta**3) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@demand@alpha**2 * object@gamma * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@demand@sigma * object@zeta**3 + object@demand@alpha**2 * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**3 - object@demand@alpha**2 * object@rho_DP**2 * object@demand@sigma * object@zeta**3 + object@demand@alpha * object@delta * object@gamma * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@gamma * object@rho_DP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@h_D * object@h_P * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**3 + object@demand@alpha * object@delta * object@h_D * object@h_P * object@rho_DP * object@demand@sigma * object@zeta**3 + object@demand@alpha * object@delta * object@rho_DP**2 * object@rho_ds * object@supply@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@rho_DP**2 * object@demand@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@h_D * object@h_P * object@rho_DP * object@demand@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@rho_DP**2 * object@demand@sigma * object@zeta**3 + object@delta * object@gamma * object@h_D * object@h_P * object@rho_DP * object@demand@sigma * object@zeta**3 - object@delta * object@gamma * object@rho_DP**2 * object@demand@sigma * object@zeta**3)) + object@zeta_SS**3 * (object@var_D * (object@gamma * object@h_P * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@h_P * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**3 + object@h_P * object@demand@sigma * object@z_PD * object@zeta**3) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@demand@sigma * object@z_DP * object@zeta**3 + object@demand@alpha * object@delta * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@demand@alpha * object@delta * object@h_D * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**3 + object@demand@alpha * object@delta * object@h_D * object@demand@sigma * object@z_DP * object@zeta**3 + object@supply@alpha * object@delta * object@h_D * object@demand@sigma * object@z_DP * object@zeta**3 + object@delta * object@gamma * object@h_D * object@demand@sigma * object@z_DP * object@zeta**3)) + object@zeta_SS**2 * (object@var_D * (-object@gamma * object@h_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@gamma * object@h_P * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**3 + object@h_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**3 - object@h_D * object@rho_DP * object@demand@sigma * object@z_PD * object@zeta**3 + object@h_P * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**3 - object@h_P * object@rho_DP * object@demand@sigma * object@z_DP * object@zeta**3) + object@sigma_D * object@sigma_P * (2 * object@demand@alpha * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@gamma * object@h_P * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**3 - 2 * object@demand@alpha * object@h_D * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**3 - 2 * object@demand@alpha * object@h_P * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**3 + 2 * object@supply@alpha * object@h_D * object@demand@sigma * object@z_PD * object@zeta**3 + 2 * object@supply@alpha * object@h_P * object@demand@sigma * object@z_DP * object@zeta**3 + object@delta * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**3 + object@delta * object@gamma * object@h_P * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@delta * object@h_D * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**3 - object@delta * object@h_P * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**3 + 2 * object@gamma * object@h_D * object@demand@sigma * object@z_PD * object@zeta**3 + 2 * object@gamma * object@h_P * object@demand@sigma * object@z_DP * object@zeta**3) + object@var_P * (-object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@rho_DP * object@demand@sigma * object@z_PD * object@zeta**3 + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**3 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@demand@sigma * object@z_DP * object@zeta**3 - object@demand@alpha * object@delta * object@gamma * object@h_D * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@demand@alpha * object@delta * object@gamma * object@h_P * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_DP * object@zeta**3 + object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_PD * object@zeta**3 - object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@demand@sigma * object@z_PD * object@zeta**3 + object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_DP * object@zeta**3 - object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@demand@sigma * object@z_DP * object@zeta**3 - object@supply@alpha * object@delta * object@h_D * object@rho_DP * object@demand@sigma * object@z_PD * object@zeta**3 - object@supply@alpha * object@delta * object@h_P * object@rho_DP * object@demand@sigma * object@z_DP * object@zeta**3 - object@delta * object@gamma * object@h_D * object@rho_DP * object@demand@sigma * object@z_PD * object@zeta**3 - object@delta * object@gamma * object@h_P * object@rho_DP * object@demand@sigma * object@z_DP * object@zeta**3)))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@var_P * (object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@omega_S * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**2) + object@sigma_P * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@omega_S * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + 2 * object@supply@alpha * object@omega_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@omega_S * object@rho_SP * object@demand@sigma * object@zeta**2 - object@delta * object@omega_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2) + object@var_S * (object@gamma * object@omega_S * object@rho_SP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@omega_S * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 + object@omega_S * object@rho_SP**2 * object@demand@sigma * object@zeta**2)) + object@zeta_DD**3 * (object@var_P * (-2 * object@supply@alpha**2 * object@gamma * object@h_D * object@rho_SP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha**2 * object@gamma * object@h_S * object@rho_dp * object@price_equation@sigma * object@zeta**2 * object@zeta_DS + 2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@demand@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_ds * object@supply@sigma * object@zeta**2 * object@zeta_DS - object@supply@alpha**2 * object@h_S * object@demand@sigma * object@zeta**2 * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@h_D * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@h_S * object@rho_ds * object@supply@sigma * object@zeta**2 * object@zeta_DS) + object@sigma_P * object@sigma_S * (4 * object@supply@alpha * object@gamma * object@h_D * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@h_P * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@h_S * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - 4 * object@supply@alpha * object@h_D * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + 4 * object@supply@alpha * object@h_D * object@rho_SP * object@demand@sigma * object@zeta**2 + 2 * object@supply@alpha * object@h_P * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_P * object@rho_DS * object@demand@sigma * object@zeta**2 + 2 * object@supply@alpha * object@h_S * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_S * object@rho_DP * object@demand@sigma * object@zeta**2 + 2 * object@delta * object@h_D * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 - object@delta * object@h_P * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta**2 - object@delta * object@h_S * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta**2) + object@var_S * (-2 * object@gamma * object@h_D * object@rho_SP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**2 + object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@gamma * object@h_P * object@rho_dp * object@price_equation@sigma * object@zeta**2 * object@zeta_DP + object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**2 + 2 * object@h_D * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**2 - 2 * object@h_D * object@rho_SP**2 * object@demand@sigma * object@zeta**2 - object@h_P * object@rho_DS * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DS * object@rho_SP * object@demand@sigma * object@zeta**2 + object@h_P * object@rho_ds * object@supply@sigma * object@zeta**2 * object@zeta_DP - object@h_P * object@demand@sigma * object@zeta**2 * object@zeta_DP - object@h_S * object@rho_DP * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**2 + object@h_S * object@rho_DP * object@rho_SP * object@demand@sigma * object@zeta**2))) + object@var_P * object@var_S * object@zeta_DD**4 * (object@demand@alpha**2 * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_D * object@demand@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@gamma * object@h_D * object@rho_dp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha * object@delta * object@h_D * object@rho_ds * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_D * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_D * object@demand@sigma * object@zeta**2 + object@delta * object@gamma * object@h_D * object@demand@sigma * object@zeta**2) + object@zeta_DD**(7 / 2) * (object@var_D * object@var_S * (object@gamma * object@omega_S * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@gamma * object@omega_S * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta_SP - object@gamma * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**2 - object@omega_S * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta_DP + object@omega_S * object@rho_DP * object@demand@sigma * object@zeta_DP - object@omega_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta_SP + object@omega_S * object@rho_SP * object@demand@sigma * object@zeta_SP + object@rho_DP * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**2 - object@rho_DP * object@demand@sigma * object@z_PS * object@zeta**2) + object@var_P * (object@var_D * (object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta_DS + object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta_SP - object@supply@alpha**2 * object@gamma * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**2 - object@supply@alpha**2 * object@omega_S * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@supply@alpha**2 * object@omega_S * object@rho_DS * object@demand@sigma * object@zeta_DS - object@supply@alpha**2 * object@omega_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta_SP + object@supply@alpha**2 * object@omega_S * object@rho_SP * object@demand@sigma * object@zeta_SP + object@supply@alpha**2 * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**2 - object@supply@alpha**2 * object@rho_DS * object@demand@sigma * object@z_SP * object@zeta**2 + object@supply@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@omega_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta_SP - object@supply@alpha * object@delta * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_S * object@rho_dp * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@gamma * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**2 + 2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_ds * object@supply@sigma * object@zeta_DS - 2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@demand@sigma * object@zeta_DS - 2 * object@demand@alpha * object@supply@alpha * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**2 + 2 * object@demand@alpha * object@supply@alpha * object@demand@sigma * object@z_SP * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@omega_S * object@rho_dp * object@price_equation@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@gamma * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@omega_S * object@demand@sigma * object@zeta_DS + 2 * object@supply@alpha * object@delta * object@demand@sigma * object@z_SP * object@zeta**2 - object@delta * object@gamma * object@omega_S * object@rho_ds * object@supply@sigma * object@zeta_DS + object@delta * object@gamma * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha**2 * object@gamma * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@gamma * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**2 - object@demand@alpha**2 * object@omega_S * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta_DP + object@demand@alpha**2 * object@omega_S * object@rho_DP * object@demand@sigma * object@zeta_DP - object@demand@alpha**2 * object@omega_S * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@demand@alpha**2 * object@omega_S * object@rho_DS * object@demand@sigma * object@zeta_DS + object@demand@alpha**2 * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@rho_DP * object@demand@sigma * object@z_PS * object@zeta**2 + object@demand@alpha**2 * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**2 - object@demand@alpha**2 * object@rho_DS * object@demand@sigma * object@z_SP * object@zeta**2 + object@demand@alpha * object@delta * object@gamma * object@omega_S * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@gamma * object@omega_S * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@gamma * object@rho_DP * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**2 - object@demand@alpha * object@delta * object@gamma * object@rho_DS * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**2 - object@demand@alpha * object@delta * object@omega_S * object@rho_DP * object@rho_ds * object@supply@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@omega_S * object@rho_DP * object@demand@sigma * object@zeta_DP - object@demand@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_ds * object@supply@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@omega_S * object@rho_DS * object@demand@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@rho_DP * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**2 - object@demand@alpha * object@delta * object@rho_DP * object@demand@sigma * object@z_PS * object@zeta**2 + object@demand@alpha * object@delta * object@rho_DS * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**2 - object@demand@alpha * object@delta * object@rho_DS * object@demand@sigma * object@z_SP * object@zeta**2 + object@supply@alpha * object@delta * object@omega_S * object@rho_DP * object@demand@sigma * object@zeta_DP + object@supply@alpha * object@delta * object@omega_S * object@rho_DS * object@demand@sigma * object@zeta_DS - object@supply@alpha * object@delta * object@rho_DP * object@demand@sigma * object@z_PS * object@zeta**2 - object@supply@alpha * object@delta * object@rho_DS * object@demand@sigma * object@z_SP * object@zeta**2 + object@delta * object@gamma * object@omega_S * object@rho_DP * object@demand@sigma * object@zeta_DP + object@delta * object@gamma * object@omega_S * object@rho_DS * object@demand@sigma * object@zeta_DS - object@delta * object@gamma * object@rho_DP * object@demand@sigma * object@z_PS * object@zeta**2 - object@delta * object@gamma * object@rho_DS * object@demand@sigma * object@z_SP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@omega_S * object@rho_dp * object@price_equation@sigma * object@zeta_SP + 2 * object@supply@alpha * object@omega_S * object@rho_ds * object@supply@sigma * object@zeta_SP - 2 * object@supply@alpha * object@omega_S * object@demand@sigma * object@zeta_SP - object@delta * object@omega_S * object@rho_ds * object@supply@sigma * object@zeta_SP) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@gamma * object@omega_S * object@rho_dp * object@price_equation@sigma * object@zeta_DP + 2 * object@demand@alpha * object@gamma * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**2 + 2 * object@demand@alpha * object@omega_S * object@rho_ds * object@supply@sigma * object@zeta_DP - 2 * object@demand@alpha * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**2 - 2 * object@supply@alpha * object@omega_S * object@demand@sigma * object@zeta_DP + 2 * object@supply@alpha * object@demand@sigma * object@z_PS * object@zeta**2 - object@delta * object@gamma * object@omega_S * object@rho_dp * object@price_equation@sigma * object@zeta_DP + object@delta * object@gamma * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**2 + object@delta * object@omega_S * object@rho_ds * object@supply@sigma * object@zeta_DP - object@delta * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**2 - 2 * object@gamma * object@omega_S * object@demand@sigma * object@zeta_DP + 2 * object@gamma * object@demand@sigma * object@z_PS * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (object@var_P * (-object@supply@alpha**2 * object@gamma * object@rho_dp * object@price_equation@sigma * object@zeta**3 + object@supply@alpha**2 * object@rho_ds * object@supply@sigma * object@zeta**3 - object@supply@alpha**2 * object@demand@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@rho_ds * object@supply@sigma * object@zeta**3) + object@var_S * (-object@gamma * object@rho_dp * object@price_equation@sigma * object@zeta**3 + object@rho_ds * object@supply@sigma * object@zeta**3 - object@demand@sigma * object@zeta**3)) + object@zeta_DD**(5 / 2) * (object@var_P * (object@supply@alpha**2 * object@gamma * object@h_P * object@h_S * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@rho_SP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**3 + object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@demand@sigma * object@zeta**3 + object@supply@alpha**2 * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**3 - object@supply@alpha**2 * object@rho_SP**2 * object@demand@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@h_P * object@h_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**3) + object@sigma_P * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@h_P * object@h_S * object@rho_dp * object@price_equation@sigma * object@zeta**3 + 2 * object@supply@alpha * object@gamma * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**3 + 2 * object@supply@alpha * object@h_P * object@h_S * object@rho_ds * object@supply@sigma * object@zeta**3 - 2 * object@supply@alpha * object@h_P * object@h_S * object@demand@sigma * object@zeta**3 - 2 * object@supply@alpha * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**3 + 2 * object@supply@alpha * object@rho_SP * object@demand@sigma * object@zeta**3 - object@delta * object@h_P * object@h_S * object@rho_ds * object@supply@sigma * object@zeta**3 + object@delta * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**3) + object@var_S * (object@gamma * object@h_P * object@h_S * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@gamma * object@rho_SP**2 * object@rho_dp * object@price_equation@sigma * object@zeta**3 - object@h_P * object@h_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@zeta**3 + object@h_P * object@h_S * object@rho_SP * object@demand@sigma * object@zeta**3 + object@rho_SP**2 * object@rho_ds * object@supply@sigma * object@zeta**3 - object@rho_SP**2 * object@demand@sigma * object@zeta**3)) + object@zeta_DD**3 * (object@var_P * (object@supply@alpha**2 * object@gamma * object@h_S * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**3 + object@supply@alpha**2 * object@h_S * object@demand@sigma * object@z_SP * object@zeta**3 + object@supply@alpha * object@delta * object@h_S * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**3) + object@var_S * (object@gamma * object@h_P * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**3 - object@h_P * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**3 + object@h_P * object@demand@sigma * object@z_PS * object@zeta**3)) + object@zeta_DD**2 * (object@var_P * (-object@supply@alpha**2 * object@gamma * object@h_P * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@h_S * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**3 + object@supply@alpha**2 * object@h_P * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_P * object@rho_SP * object@demand@sigma * object@z_SP * object@zeta**3 + object@supply@alpha**2 * object@h_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_SP * object@demand@sigma * object@z_PS * object@zeta**3 - object@supply@alpha * object@delta * object@h_P * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**3 - object@supply@alpha * object@delta * object@h_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**3) + object@sigma_P * object@sigma_S * (2 * object@supply@alpha * object@gamma * object@h_P * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@gamma * object@h_S * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**3 - 2 * object@supply@alpha * object@h_P * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@h_P * object@demand@sigma * object@z_SP * object@zeta**3 - 2 * object@supply@alpha * object@h_S * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**3 + 2 * object@supply@alpha * object@h_S * object@demand@sigma * object@z_PS * object@zeta**3 + object@delta * object@h_P * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**3 + object@delta * object@h_S * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**3) + object@var_S * (-object@gamma * object@h_P * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@gamma * object@h_S * object@rho_SP * object@rho_dp * object@price_equation@sigma * object@z_PS * object@zeta**3 + object@h_P * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_SP * object@zeta**3 - object@h_P * object@rho_SP * object@demand@sigma * object@z_SP * object@zeta**3 + object@h_S * object@rho_SP * object@rho_ds * object@supply@sigma * object@z_PS * object@zeta**3 - object@h_S * object@rho_SP * object@demand@sigma * object@z_PS * object@zeta**3))))) / (2 * object@delta**2 * object@var_D * object@var_P * object@var_S * object@demand@sigma * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_other_variance", function(object) {
  standardGeneric("partial_other_variance")
})

setMethod("partial_other_variance", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  -(object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@var_P * object@zeta_SS**4 * (object@demand@alpha * object@delta * object@h_S * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_ds * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@supply@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@h_S * object@rho_ds * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_S * object@supply@sigma * object@zeta**2 - object@delta * object@gamma * object@h_S * object@supply@sigma * object@zeta**2) + object@var_S * (object@zeta_SS**(5 / 2) * (object@var_D * (object@gamma * object@omega_D * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@omega_D * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 - object@omega_D * object@rho_DP**2 * object@supply@sigma * object@zeta**2) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@omega_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@omega_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha * object@omega_D * object@rho_DP * object@supply@sigma * object@zeta**2 - object@delta * object@omega_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**2) + object@var_P * (object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@omega_D * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**2)) + object@zeta_SS**3 * (object@var_D * (object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@gamma * object@h_P * object@rho_sp * object@price_equation@sigma * object@zeta**2 * object@zeta_SP - 2 * object@gamma * object@h_S * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@h_D * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@h_D * object@rho_DP * object@rho_SP * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DP * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta**2 - object@h_P * object@rho_DP * object@rho_DS * object@supply@sigma * object@zeta**2 - object@h_P * object@rho_ds * object@demand@sigma * object@zeta**2 * object@zeta_SP + object@h_P * object@supply@sigma * object@zeta**2 * object@zeta_SP - 2 * object@h_S * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@h_S * object@rho_DP**2 * object@supply@sigma * object@zeta**2) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@h_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@gamma * object@h_P * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta**2 + 4 * object@demand@alpha * object@gamma * object@h_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@h_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_D * object@rho_SP * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha * object@h_P * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_P * object@rho_DS * object@supply@sigma * object@zeta**2 + 4 * object@demand@alpha * object@h_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**2 - 4 * object@demand@alpha * object@h_S * object@rho_DP * object@supply@sigma * object@zeta**2 - object@delta * object@h_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@delta * object@h_P * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@delta * object@h_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**2) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@demand@alpha**2 * object@gamma * object@h_D * object@rho_sp * object@price_equation@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha**2 * object@gamma * object@h_S * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@supply@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@rho_ds * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@h_D * object@supply@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@demand@alpha * object@delta * object@h_D * object@rho_ds * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@h_S * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**2))) + object@zeta_SS**(7 / 2) * (object@var_D * object@var_S * (object@gamma * object@omega_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta_DP + object@gamma * object@omega_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta_SP - object@gamma * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**2 + object@omega_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta_DP - object@omega_D * object@rho_DP * object@supply@sigma * object@zeta_DP + object@omega_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta_SP - object@omega_D * object@rho_SP * object@supply@sigma * object@zeta_SP - object@rho_SP * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**2 + object@rho_SP * object@supply@sigma * object@z_PD * object@zeta**2) + object@var_P * (object@var_D * (object@demand@alpha * object@delta * object@omega_D * object@rho_DS * object@supply@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@omega_D * object@rho_SP * object@supply@sigma * object@zeta_SP - object@demand@alpha * object@delta * object@rho_DS * object@supply@sigma * object@z_DP * object@zeta**2 - object@demand@alpha * object@delta * object@rho_SP * object@supply@sigma * object@z_PD * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta_DS + object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta_SP - object@supply@alpha**2 * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@gamma * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**2 + object@supply@alpha**2 * object@omega_D * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS - object@supply@alpha**2 * object@omega_D * object@rho_DS * object@supply@sigma * object@zeta_DS + object@supply@alpha**2 * object@omega_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta_SP - object@supply@alpha**2 * object@omega_D * object@rho_SP * object@supply@sigma * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**2 + object@supply@alpha**2 * object@rho_DS * object@supply@sigma * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**2 + object@supply@alpha**2 * object@rho_SP * object@supply@sigma * object@z_PD * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@omega_D * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta_DS - object@supply@alpha * object@delta * object@gamma * object@omega_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta_SP + object@supply@alpha * object@delta * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**2 + object@supply@alpha * object@delta * object@gamma * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**2 - object@supply@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@omega_D * object@rho_DS * object@supply@sigma * object@zeta_DS - object@supply@alpha * object@delta * object@omega_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta_SP + object@supply@alpha * object@delta * object@omega_D * object@rho_SP * object@supply@sigma * object@zeta_SP + object@supply@alpha * object@delta * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**2 - object@supply@alpha * object@delta * object@rho_DS * object@supply@sigma * object@z_DP * object@zeta**2 + object@supply@alpha * object@delta * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**2 - object@supply@alpha * object@delta * object@rho_SP * object@supply@sigma * object@z_PD * object@zeta**2 - object@delta * object@gamma * object@omega_D * object@rho_DS * object@supply@sigma * object@zeta_DS - object@delta * object@gamma * object@omega_D * object@rho_SP * object@supply@sigma * object@zeta_SP + object@delta * object@gamma * object@rho_DS * object@supply@sigma * object@z_DP * object@zeta**2 + object@delta * object@gamma * object@rho_SP * object@supply@sigma * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_D * object@rho_sp * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@gamma * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_ds * object@demand@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@supply@sigma * object@z_DP * object@zeta**2 + object@demand@alpha * object@delta * object@gamma * object@omega_D * object@rho_sp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@gamma * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@omega_D * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha * object@delta * object@supply@sigma * object@z_DP * object@zeta**2 + object@delta * object@gamma * object@omega_D * object@rho_ds * object@demand@sigma * object@zeta_DS - object@delta * object@gamma * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta_DP + object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha**2 * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**2 + object@demand@alpha**2 * object@omega_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta_DP - object@demand@alpha**2 * object@omega_D * object@rho_DP * object@supply@sigma * object@zeta_DP + object@demand@alpha**2 * object@omega_D * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS - object@demand@alpha**2 * object@omega_D * object@rho_DS * object@supply@sigma * object@zeta_DS - object@demand@alpha**2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**2 + object@demand@alpha**2 * object@rho_DS * object@supply@sigma * object@z_DP * object@zeta**2 + object@demand@alpha * object@delta * object@omega_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (2 * object@demand@alpha * object@omega_D * object@supply@sigma * object@zeta_SP - 2 * object@demand@alpha * object@supply@sigma * object@z_PD * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@omega_D * object@rho_sp * object@price_equation@sigma * object@zeta_SP + 2 * object@supply@alpha * object@gamma * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**2 - 2 * object@supply@alpha * object@omega_D * object@rho_ds * object@demand@sigma * object@zeta_SP + 2 * object@supply@alpha * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**2 + object@delta * object@gamma * object@omega_D * object@rho_sp * object@price_equation@sigma * object@zeta_SP - object@delta * object@gamma * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**2 + object@delta * object@omega_D * object@rho_ds * object@demand@sigma * object@zeta_SP - object@delta * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**2 - 2 * object@gamma * object@omega_D * object@supply@sigma * object@zeta_SP + 2 * object@gamma * object@supply@sigma * object@z_PD * object@zeta**2) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@gamma * object@omega_D * object@rho_sp * object@price_equation@sigma * object@zeta_DP - 2 * object@demand@alpha * object@omega_D * object@rho_ds * object@demand@sigma * object@zeta_DP + 2 * object@demand@alpha * object@omega_D * object@supply@sigma * object@zeta_DP - object@delta * object@omega_D * object@rho_ds * object@demand@sigma * object@zeta_DP)))) + object@var_S * (object@zeta_SS**(7 / 2) * (object@var_D * (-object@gamma * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@rho_ds * object@demand@sigma * object@zeta**3 + object@supply@sigma * object@zeta**3) + object@var_P * (-object@demand@alpha**2 * object@gamma * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@demand@alpha**2 * object@rho_ds * object@demand@sigma * object@zeta**3 + object@demand@alpha**2 * object@supply@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@rho_ds * object@demand@sigma * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@var_D * (object@gamma * object@h_D * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@gamma * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**3 + object@h_D * object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**3 - object@h_D * object@h_P * object@rho_DP * object@supply@sigma * object@zeta**3 - object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**3 + object@rho_DP**2 * object@supply@sigma * object@zeta**3) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@h_D * object@h_P * object@rho_sp * object@price_equation@sigma * object@zeta**3 + 2 * object@demand@alpha * object@gamma * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta**3 - 2 * object@demand@alpha * object@h_D * object@h_P * object@rho_ds * object@demand@sigma * object@zeta**3 + 2 * object@demand@alpha * object@h_D * object@h_P * object@supply@sigma * object@zeta**3 + 2 * object@demand@alpha * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**3 - 2 * object@demand@alpha * object@rho_DP * object@supply@sigma * object@zeta**3 - object@delta * object@h_D * object@h_P * object@rho_ds * object@demand@sigma * object@zeta**3 + object@delta * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**3) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@demand@alpha**2 * object@gamma * object@rho_DP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@supply@sigma * object@zeta**3 - object@demand@alpha**2 * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**3 + object@demand@alpha**2 * object@rho_DP**2 * object@supply@sigma * object@zeta**3 + object@demand@alpha * object@delta * object@h_D * object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@rho_DP**2 * object@rho_ds * object@demand@sigma * object@zeta**3)) + object@zeta_SS**3 * (object@var_D * (object@gamma * object@h_P * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**3 + object@h_P * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**3 - object@h_P * object@supply@sigma * object@z_PD * object@zeta**3) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@supply@sigma * object@z_DP * object@zeta**3 + object@demand@alpha * object@delta * object@h_D * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**3)) + object@zeta_SS**2 * (object@var_D * (-object@gamma * object@h_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@gamma * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@h_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**3 + object@h_D * object@rho_DP * object@supply@sigma * object@z_PD * object@zeta**3 - object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**3 + object@h_P * object@rho_DP * object@supply@sigma * object@z_DP * object@zeta**3) + object@sigma_D * object@sigma_P * (2 * object@demand@alpha * object@gamma * object@h_D * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@gamma * object@h_P * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**3 + 2 * object@demand@alpha * object@h_D * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**3 - 2 * object@demand@alpha * object@h_D * object@supply@sigma * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@h_P * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**3 - 2 * object@demand@alpha * object@h_P * object@supply@sigma * object@z_DP * object@zeta**3 + object@delta * object@h_D * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**3 + object@delta * object@h_P * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**3) + object@var_P * (-object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@rho_DP * object@supply@sigma * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**3 + object@demand@alpha**2 * object@h_P * object@rho_DP * object@supply@sigma * object@z_DP * object@zeta**3 - object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_PD * object@zeta**3 - object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_DP * object@zeta**3)))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@var_P * (object@demand@alpha * object@delta * object@omega_S * object@rho_SP**2 * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@supply@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@omega_S * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@omega_S * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@omega_S * object@rho_SP**2 * object@supply@sigma * object@zeta**2 - object@delta * object@gamma * object@omega_S * object@rho_SP**2 * object@supply@sigma * object@zeta**2) + object@sigma_P * object@sigma_S * (2 * object@demand@alpha * object@omega_S * object@rho_SP * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@omega_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 + object@delta * object@gamma * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@delta * object@omega_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - 2 * object@gamma * object@omega_S * object@rho_SP * object@supply@sigma * object@zeta**2) + object@var_S * (object@gamma * object@omega_S * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@omega_S * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 - object@omega_S * object@rho_SP**2 * object@supply@sigma * object@zeta**2)) + object@zeta_DD**3 * (object@var_P * (-2 * object@demand@alpha * object@delta * object@h_D * object@rho_SP**2 * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma * object@zeta**2 - object@demand@alpha * object@delta * object@h_S * object@supply@sigma * object@zeta**2 * object@zeta_DS - 2 * object@supply@alpha**2 * object@gamma * object@h_D * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha**2 * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@zeta**2 * object@zeta_DS - 2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@rho_ds * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@supply@alpha**2 * object@h_S * object@supply@sigma * object@zeta**2 * object@zeta_DS + 2 * object@supply@alpha * object@delta * object@gamma * object@h_D * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@zeta**2 * object@zeta_DS + 2 * object@supply@alpha * object@delta * object@h_D * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 - 2 * object@supply@alpha * object@delta * object@h_D * object@rho_SP**2 * object@supply@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_S * object@rho_ds * object@demand@sigma * object@zeta**2 * object@zeta_DS - object@supply@alpha * object@delta * object@h_S * object@supply@sigma * object@zeta**2 * object@zeta_DS + 2 * object@delta * object@gamma * object@h_D * object@rho_SP**2 * object@supply@sigma * object@zeta**2 - object@delta * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma * object@zeta**2 - object@delta * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma * object@zeta**2 + object@delta * object@gamma * object@h_S * object@supply@sigma * object@zeta**2 * object@zeta_DS) + object@sigma_P * object@sigma_S * (-4 * object@demand@alpha * object@h_D * object@rho_SP * object@supply@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_P * object@rho_DS * object@supply@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_S * object@rho_DP * object@supply@sigma * object@zeta**2 + 4 * object@supply@alpha * object@gamma * object@h_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@h_P * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@h_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta**2 + 4 * object@supply@alpha * object@h_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_P * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**2 - 2 * object@delta * object@gamma * object@h_D * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@delta * object@gamma * object@h_P * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@delta * object@gamma * object@h_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@delta * object@h_D * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 + object@delta * object@h_P * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta**2 + object@delta * object@h_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta**2 + 4 * object@gamma * object@h_D * object@rho_SP * object@supply@sigma * object@zeta**2 - 2 * object@gamma * object@h_P * object@rho_DS * object@supply@sigma * object@zeta**2 - 2 * object@gamma * object@h_S * object@rho_DP * object@supply@sigma * object@zeta**2) + object@var_S * (-2 * object@gamma * object@h_D * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - object@gamma * object@h_P * object@rho_sp * object@price_equation@sigma * object@zeta**2 * object@zeta_DP + object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**2 - 2 * object@h_D * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**2 + 2 * object@h_D * object@rho_SP**2 * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DS * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@h_P * object@rho_DS * object@rho_SP * object@supply@sigma * object@zeta**2 - object@h_P * object@rho_ds * object@demand@sigma * object@zeta**2 * object@zeta_DP + object@h_P * object@supply@sigma * object@zeta**2 * object@zeta_DP + object@h_S * object@rho_DP * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**2 - object@h_S * object@rho_DP * object@rho_SP * object@supply@sigma * object@zeta**2))) + object@var_P * object@var_S * object@zeta_DD**4 * (object@demand@alpha**2 * object@gamma * object@h_D * object@rho_sp * object@price_equation@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_D * object@rho_ds * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_D * object@rho_ds * object@demand@sigma * object@zeta**2) + object@zeta_DD**(7 / 2) * (object@var_D * object@var_S * (object@gamma * object@omega_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta_DP + object@gamma * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta_SP - object@gamma * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**2 + object@omega_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta_DP - object@omega_S * object@rho_DP * object@supply@sigma * object@zeta_DP + object@omega_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta_SP - object@omega_S * object@rho_SP * object@supply@sigma * object@zeta_SP - object@rho_DP * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**2 + object@rho_DP * object@supply@sigma * object@z_PS * object@zeta**2) + object@var_P * (object@var_D * (object@demand@alpha * object@delta * object@omega_S * object@rho_DS * object@supply@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@omega_S * object@rho_SP * object@supply@sigma * object@zeta_SP - object@demand@alpha * object@delta * object@rho_DS * object@supply@sigma * object@z_SP * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta_DS + object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta_SP - object@supply@alpha**2 * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**2 + object@supply@alpha**2 * object@omega_S * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS - object@supply@alpha**2 * object@omega_S * object@rho_DS * object@supply@sigma * object@zeta_DS + object@supply@alpha**2 * object@omega_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta_SP - object@supply@alpha**2 * object@omega_S * object@rho_SP * object@supply@sigma * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**2 + object@supply@alpha**2 * object@rho_DS * object@supply@sigma * object@z_SP * object@zeta**2 - object@supply@alpha * object@delta * object@gamma * object@omega_S * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta_DS - object@supply@alpha * object@delta * object@gamma * object@omega_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta_SP + object@supply@alpha * object@delta * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**2 - object@supply@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@omega_S * object@rho_DS * object@supply@sigma * object@zeta_DS - object@supply@alpha * object@delta * object@omega_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta_SP + object@supply@alpha * object@delta * object@omega_S * object@rho_SP * object@supply@sigma * object@zeta_SP + object@supply@alpha * object@delta * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**2 - object@supply@alpha * object@delta * object@rho_DS * object@supply@sigma * object@z_SP * object@zeta**2 - object@delta * object@gamma * object@omega_S * object@rho_DS * object@supply@sigma * object@zeta_DS - object@delta * object@gamma * object@omega_S * object@rho_SP * object@supply@sigma * object@zeta_SP + object@delta * object@gamma * object@rho_DS * object@supply@sigma * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_S * object@rho_sp * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@gamma * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_ds * object@demand@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@supply@sigma * object@z_SP * object@zeta**2 + object@demand@alpha * object@delta * object@gamma * object@omega_S * object@rho_sp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@gamma * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@omega_S * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha * object@delta * object@supply@sigma * object@z_SP * object@zeta**2 + object@delta * object@gamma * object@omega_S * object@rho_ds * object@demand@sigma * object@zeta_DS - object@delta * object@gamma * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@zeta_DP + object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@zeta_DS - object@demand@alpha**2 * object@gamma * object@rho_DP * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@gamma * object@rho_DS * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**2 + object@demand@alpha**2 * object@omega_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta_DP - object@demand@alpha**2 * object@omega_S * object@rho_DP * object@supply@sigma * object@zeta_DP + object@demand@alpha**2 * object@omega_S * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS - object@demand@alpha**2 * object@omega_S * object@rho_DS * object@supply@sigma * object@zeta_DS - object@demand@alpha**2 * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**2 + object@demand@alpha**2 * object@rho_DP * object@supply@sigma * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**2 + object@demand@alpha**2 * object@rho_DS * object@supply@sigma * object@z_SP * object@zeta**2 + object@demand@alpha * object@delta * object@omega_S * object@rho_DP * object@rho_ds * object@demand@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_ds * object@demand@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@rho_DP * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**2 - object@demand@alpha * object@delta * object@rho_DS * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (2 * object@demand@alpha * object@omega_S * object@supply@sigma * object@zeta_SP - 2 * object@supply@alpha * object@gamma * object@omega_S * object@rho_sp * object@price_equation@sigma * object@zeta_SP - 2 * object@supply@alpha * object@omega_S * object@rho_ds * object@demand@sigma * object@zeta_SP + object@delta * object@gamma * object@omega_S * object@rho_sp * object@price_equation@sigma * object@zeta_SP + object@delta * object@omega_S * object@rho_ds * object@demand@sigma * object@zeta_SP - 2 * object@gamma * object@omega_S * object@supply@sigma * object@zeta_SP) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@gamma * object@omega_S * object@rho_sp * object@price_equation@sigma * object@zeta_DP + 2 * object@demand@alpha * object@gamma * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**2 - 2 * object@demand@alpha * object@omega_S * object@rho_ds * object@demand@sigma * object@zeta_DP + 2 * object@demand@alpha * object@omega_S * object@supply@sigma * object@zeta_DP + 2 * object@demand@alpha * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**2 - 2 * object@demand@alpha * object@supply@sigma * object@z_PS * object@zeta**2 - object@delta * object@omega_S * object@rho_ds * object@demand@sigma * object@zeta_DP + object@delta * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (object@var_P * (-object@demand@alpha * object@delta * object@supply@sigma * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@supply@alpha**2 * object@rho_ds * object@demand@sigma * object@zeta**3 + object@supply@alpha**2 * object@supply@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@gamma * object@rho_sp * object@price_equation@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@rho_ds * object@demand@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@supply@sigma * object@zeta**3 + object@delta * object@gamma * object@supply@sigma * object@zeta**3) + object@var_S * (-object@gamma * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@rho_ds * object@demand@sigma * object@zeta**3 + object@supply@sigma * object@zeta**3)) + object@zeta_DD**(5 / 2) * (object@var_P * (object@demand@alpha * object@delta * object@h_P * object@h_S * object@rho_SP * object@supply@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@rho_SP**2 * object@supply@sigma * object@zeta**3 + object@supply@alpha**2 * object@gamma * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**3 + object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**3 - object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@supply@sigma * object@zeta**3 - object@supply@alpha**2 * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**3 + object@supply@alpha**2 * object@rho_SP**2 * object@supply@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@gamma * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@gamma * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@h_P * object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@h_P * object@h_S * object@rho_SP * object@supply@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@rho_SP**2 * object@supply@sigma * object@zeta**3 - object@delta * object@gamma * object@h_P * object@h_S * object@rho_SP * object@supply@sigma * object@zeta**3 + object@delta * object@gamma * object@rho_SP**2 * object@supply@sigma * object@zeta**3) + object@sigma_P * object@sigma_S * (2 * object@demand@alpha * object@h_P * object@h_S * object@supply@sigma * object@zeta**3 - 2 * object@demand@alpha * object@rho_SP * object@supply@sigma * object@zeta**3 - 2 * object@supply@alpha * object@gamma * object@h_P * object@h_S * object@rho_sp * object@price_equation@sigma * object@zeta**3 + 2 * object@supply@alpha * object@gamma * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**3 - 2 * object@supply@alpha * object@h_P * object@h_S * object@rho_ds * object@demand@sigma * object@zeta**3 + 2 * object@supply@alpha * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**3 + object@delta * object@gamma * object@h_P * object@h_S * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@delta * object@gamma * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**3 + object@delta * object@h_P * object@h_S * object@rho_ds * object@demand@sigma * object@zeta**3 - object@delta * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**3 - 2 * object@gamma * object@h_P * object@h_S * object@supply@sigma * object@zeta**3 + 2 * object@gamma * object@rho_SP * object@supply@sigma * object@zeta**3) + object@var_S * (object@gamma * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@zeta**3 - object@gamma * object@rho_SP**2 * object@rho_sp * object@price_equation@sigma * object@zeta**3 + object@h_P * object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@zeta**3 - object@h_P * object@h_S * object@rho_SP * object@supply@sigma * object@zeta**3 - object@rho_SP**2 * object@rho_ds * object@demand@sigma * object@zeta**3 + object@rho_SP**2 * object@supply@sigma * object@zeta**3)) + object@zeta_DD**3 * (object@var_P * (object@demand@alpha * object@delta * object@h_S * object@supply@sigma * object@z_SP * object@zeta**3 + object@supply@alpha**2 * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**3 + object@supply@alpha**2 * object@h_S * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@supply@sigma * object@z_SP * object@zeta**3 - object@supply@alpha * object@delta * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@supply@alpha * object@delta * object@h_S * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**3 + object@supply@alpha * object@delta * object@h_S * object@supply@sigma * object@z_SP * object@zeta**3 - object@delta * object@gamma * object@h_S * object@supply@sigma * object@z_SP * object@zeta**3) + object@var_S * (object@gamma * object@h_P * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**3 + object@h_P * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**3 - object@h_P * object@supply@sigma * object@z_PS * object@zeta**3)) + object@zeta_DD**2 * (object@var_P * (-object@demand@alpha * object@delta * object@h_P * object@rho_SP * object@supply@sigma * object@z_SP * object@zeta**3 - object@demand@alpha * object@delta * object@h_S * object@rho_SP * object@supply@sigma * object@z_PS * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@h_P * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**3 - object@supply@alpha**2 * object@h_P * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**3 + object@supply@alpha**2 * object@h_P * object@rho_SP * object@supply@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**3 + object@supply@alpha**2 * object@h_S * object@rho_SP * object@supply@sigma * object@z_PS * object@zeta**3 + object@supply@alpha * object@delta * object@gamma * object@h_P * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**3 + object@supply@alpha * object@delta * object@gamma * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**3 + object@supply@alpha * object@delta * object@h_P * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**3 - object@supply@alpha * object@delta * object@h_P * object@rho_SP * object@supply@sigma * object@z_SP * object@zeta**3 + object@supply@alpha * object@delta * object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**3 - object@supply@alpha * object@delta * object@h_S * object@rho_SP * object@supply@sigma * object@z_PS * object@zeta**3 + object@delta * object@gamma * object@h_P * object@rho_SP * object@supply@sigma * object@z_SP * object@zeta**3 + object@delta * object@gamma * object@h_S * object@rho_SP * object@supply@sigma * object@z_PS * object@zeta**3) + object@sigma_P * object@sigma_S * (-2 * object@demand@alpha * object@h_P * object@supply@sigma * object@z_SP * object@zeta**3 - 2 * object@demand@alpha * object@h_S * object@supply@sigma * object@z_PS * object@zeta**3 + 2 * object@supply@alpha * object@gamma * object@h_P * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**3 + 2 * object@supply@alpha * object@h_P * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@h_S * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**3 - object@delta * object@gamma * object@h_P * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@delta * object@gamma * object@h_S * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**3 - object@delta * object@h_P * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**3 - object@delta * object@h_S * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**3 + 2 * object@gamma * object@h_P * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@gamma * object@h_S * object@supply@sigma * object@z_PS * object@zeta**3) + object@var_S * (-object@gamma * object@h_P * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@gamma * object@h_S * object@rho_SP * object@rho_sp * object@price_equation@sigma * object@z_PS * object@zeta**3 - object@h_P * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_SP * object@zeta**3 + object@h_P * object@rho_SP * object@supply@sigma * object@z_SP * object@zeta**3 - object@h_S * object@rho_SP * object@rho_ds * object@demand@sigma * object@z_PS * object@zeta**3 + object@h_S * object@rho_SP * object@supply@sigma * object@z_PS * object@zeta**3))))) / (2 * object@delta**2 * object@var_D * object@var_P * object@var_S * object@supply@sigma * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_price_variance", function(object) {
  standardGeneric("partial_price_variance")
})

setMethod("partial_price_variance", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  object@gamma * (object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@var_P * object@zeta_SS**4 * (object@supply@alpha**2 * object@gamma * object@h_S * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_dp * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@rho_sp * object@supply@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_S * object@rho_sp * object@supply@sigma * object@zeta**2) + object@var_S * (object@zeta_SS**(5 / 2) * (object@var_D * (object@gamma * object@omega_D * object@rho_DP**2 * object@price_equation@sigma * object@zeta**2 + object@omega_D * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 - object@omega_D * object@rho_DP**2 * object@rho_sp * object@supply@sigma * object@zeta**2) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@omega_D * object@rho_DP * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha * object@omega_D * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@delta * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**2) + object@var_P * (object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP**2 * object@price_equation@sigma * object@zeta**2 + object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@rho_sp * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@omega_D * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**2)) + object@zeta_SS**3 * (object@var_D * (object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@price_equation@sigma * object@zeta**2 + object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@price_equation@sigma * object@zeta**2 - object@gamma * object@h_P * object@price_equation@sigma * object@zeta**2 * object@zeta_SP - 2 * object@gamma * object@h_S * object@rho_DP**2 * object@price_equation@sigma * object@zeta**2 + object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@h_D * object@rho_DP * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta**2 - object@h_P * object@rho_DP * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta**2 - object@h_P * object@rho_dp * object@demand@sigma * object@zeta**2 * object@zeta_SP + object@h_P * object@rho_sp * object@supply@sigma * object@zeta**2 * object@zeta_SP - 2 * object@h_S * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@h_S * object@rho_DP**2 * object@rho_sp * object@supply@sigma * object@zeta**2) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@h_D * object@rho_SP * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@gamma * object@h_P * object@rho_DS * object@price_equation@sigma * object@zeta**2 + 4 * object@demand@alpha * object@gamma * object@h_S * object@rho_DP * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha * object@h_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_D * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha * object@h_P * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha * object@h_P * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta**2 + 4 * object@demand@alpha * object@h_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**2 - 4 * object@demand@alpha * object@h_S * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@delta * object@h_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@delta * object@h_P * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@delta * object@h_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**2) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@price_equation@sigma * object@zeta**2 - object@demand@alpha**2 * object@gamma * object@h_D * object@price_equation@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@price_equation@sigma * object@zeta**2 - 2 * object@demand@alpha**2 * object@gamma * object@h_S * object@rho_DP**2 * object@price_equation@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@rho_dp * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@h_D * object@rho_sp * object@supply@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@rho_sp * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@demand@alpha * object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta**2 - 2 * object@demand@alpha * object@delta * object@h_S * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**2))) + object@zeta_SS**(7 / 2) * (object@var_D * object@var_S * (object@gamma * object@omega_D * object@rho_DP * object@price_equation@sigma * object@zeta_DP + object@gamma * object@omega_D * object@rho_SP * object@price_equation@sigma * object@zeta_SP - object@gamma * object@rho_SP * object@price_equation@sigma * object@z_PD * object@zeta**2 + object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta_DP - object@omega_D * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta_DP + object@omega_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta_SP - object@omega_D * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta_SP - object@rho_SP * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**2 + object@rho_SP * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**2) + object@var_P * (object@var_D * (object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@price_equation@sigma * object@zeta_DS + object@supply@alpha**2 * object@gamma * object@omega_D * object@rho_SP * object@price_equation@sigma * object@zeta_SP - object@supply@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@gamma * object@rho_SP * object@price_equation@sigma * object@z_PD * object@zeta**2 + object@supply@alpha**2 * object@omega_D * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta_DS - object@supply@alpha**2 * object@omega_D * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta_DS + object@supply@alpha**2 * object@omega_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta_SP - object@supply@alpha**2 * object@omega_D * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**2 + object@supply@alpha**2 * object@rho_DS * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@rho_SP * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**2 + object@supply@alpha**2 * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**2 + object@supply@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@omega_D * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta_SP - object@supply@alpha * object@delta * object@rho_DS * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**2 - object@supply@alpha * object@delta * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_D * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@gamma * object@price_equation@sigma * object@z_DP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_dp * object@demand@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_sp * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**2 - object@demand@alpha * object@delta * object@omega_D * object@rho_sp * object@supply@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**2 - object@supply@alpha * object@delta * object@omega_D * object@rho_dp * object@demand@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DP * object@price_equation@sigma * object@zeta_DP + object@demand@alpha**2 * object@gamma * object@omega_D * object@rho_DS * object@price_equation@sigma * object@zeta_DS - object@demand@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma * object@z_DP * object@zeta**2 + object@demand@alpha**2 * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta_DP - object@demand@alpha**2 * object@omega_D * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta_DP + object@demand@alpha**2 * object@omega_D * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta_DS - object@demand@alpha**2 * object@omega_D * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta_DS - object@demand@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**2 + object@demand@alpha**2 * object@rho_DS * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**2 + object@demand@alpha * object@delta * object@omega_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@omega_D * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@rho_DS * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@omega_D * object@price_equation@sigma * object@zeta_SP + 2 * object@supply@alpha * object@gamma * object@price_equation@sigma * object@z_PD * object@zeta**2 - 2 * object@supply@alpha * object@omega_D * object@rho_dp * object@demand@sigma * object@zeta_SP + 2 * object@supply@alpha * object@omega_D * object@rho_sp * object@supply@sigma * object@zeta_SP + 2 * object@supply@alpha * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**2 - 2 * object@supply@alpha * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**2 - object@delta * object@omega_D * object@rho_sp * object@supply@sigma * object@zeta_SP + object@delta * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**2) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@gamma * object@omega_D * object@price_equation@sigma * object@zeta_DP - 2 * object@demand@alpha * object@omega_D * object@rho_dp * object@demand@sigma * object@zeta_DP + 2 * object@demand@alpha * object@omega_D * object@rho_sp * object@supply@sigma * object@zeta_DP - object@delta * object@omega_D * object@rho_dp * object@demand@sigma * object@zeta_DP)))) + object@var_S * (object@zeta_SS**(7 / 2) * (object@var_D * (-object@gamma * object@price_equation@sigma * object@zeta**3 - object@rho_dp * object@demand@sigma * object@zeta**3 + object@rho_sp * object@supply@sigma * object@zeta**3) + object@var_P * (-object@demand@alpha**2 * object@gamma * object@price_equation@sigma * object@zeta**3 - object@demand@alpha**2 * object@rho_dp * object@demand@sigma * object@zeta**3 + object@demand@alpha**2 * object@rho_sp * object@supply@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@rho_dp * object@demand@sigma * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@var_D * (object@gamma * object@h_D * object@h_P * object@rho_DP * object@price_equation@sigma * object@zeta**3 - object@gamma * object@rho_DP**2 * object@price_equation@sigma * object@zeta**3 + object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**3 - object@h_D * object@h_P * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta**3 - object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**3 + object@rho_DP**2 * object@rho_sp * object@supply@sigma * object@zeta**3) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@gamma * object@h_D * object@h_P * object@price_equation@sigma * object@zeta**3 + 2 * object@demand@alpha * object@gamma * object@rho_DP * object@price_equation@sigma * object@zeta**3 - 2 * object@demand@alpha * object@h_D * object@h_P * object@rho_dp * object@demand@sigma * object@zeta**3 + 2 * object@demand@alpha * object@h_D * object@h_P * object@rho_sp * object@supply@sigma * object@zeta**3 + 2 * object@demand@alpha * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**3 - 2 * object@demand@alpha * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta**3 - object@delta * object@h_D * object@h_P * object@rho_dp * object@demand@sigma * object@zeta**3 + object@delta * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**3) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@h_P * object@rho_DP * object@price_equation@sigma * object@zeta**3 - object@demand@alpha**2 * object@gamma * object@rho_DP**2 * object@price_equation@sigma * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta**3 - object@demand@alpha**2 * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**3 + object@demand@alpha**2 * object@rho_DP**2 * object@rho_sp * object@supply@sigma * object@zeta**3 + object@demand@alpha * object@delta * object@h_D * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**3 - object@demand@alpha * object@delta * object@rho_DP**2 * object@rho_dp * object@demand@sigma * object@zeta**3)) + object@zeta_SS**3 * (object@var_D * (object@gamma * object@h_P * object@price_equation@sigma * object@z_PD * object@zeta**3 + object@h_P * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**3 - object@h_P * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**3) + object@var_P * (object@demand@alpha**2 * object@gamma * object@h_D * object@price_equation@sigma * object@z_DP * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**3 + object@demand@alpha * object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**3)) + object@zeta_SS**2 * (object@var_D * (-object@gamma * object@h_D * object@rho_DP * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@gamma * object@h_P * object@rho_DP * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@h_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**3 + object@h_D * object@rho_DP * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**3 - object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**3 + object@h_P * object@rho_DP * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**3) + object@sigma_D * object@sigma_P * (2 * object@demand@alpha * object@gamma * object@h_D * object@price_equation@sigma * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@gamma * object@h_P * object@price_equation@sigma * object@z_DP * object@zeta**3 + 2 * object@demand@alpha * object@h_D * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**3 - 2 * object@demand@alpha * object@h_D * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@h_P * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**3 - 2 * object@demand@alpha * object@h_P * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**3 + object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**3 + object@delta * object@h_P * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**3) + object@var_P * (-object@demand@alpha**2 * object@gamma * object@h_D * object@rho_DP * object@price_equation@sigma * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@gamma * object@h_P * object@rho_DP * object@price_equation@sigma * object@z_DP * object@zeta**3 - object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**3 + object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_sp * object@supply@sigma * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**3 + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_sp * object@supply@sigma * object@z_DP * object@zeta**3 - object@demand@alpha * object@delta * object@h_D * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_PD * object@zeta**3 - object@demand@alpha * object@delta * object@h_P * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_DP * object@zeta**3)))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@var_P * (object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP**2 * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@omega_S * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**2) + object@sigma_P * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@omega_S * object@rho_SP * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@omega_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@supply@alpha * object@omega_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@delta * object@omega_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2) + object@var_S * (object@gamma * object@omega_S * object@rho_SP**2 * object@price_equation@sigma * object@zeta**2 + object@omega_S * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 - object@omega_S * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**2)) + object@zeta_DD**3 * (object@var_P * (-2 * object@supply@alpha**2 * object@gamma * object@h_D * object@rho_SP**2 * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@price_equation@sigma * object@zeta**2 + object@supply@alpha**2 * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@price_equation@sigma * object@zeta**2 - object@supply@alpha**2 * object@gamma * object@h_S * object@price_equation@sigma * object@zeta**2 * object@zeta_DS - 2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@rho_dp * object@demand@sigma * object@zeta**2 * object@zeta_DS + object@supply@alpha**2 * object@h_S * object@rho_sp * object@supply@sigma * object@zeta**2 * object@zeta_DS - 2 * object@supply@alpha * object@delta * object@h_D * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 + object@supply@alpha * object@delta * object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@supply@alpha * object@delta * object@h_S * object@rho_sp * object@supply@sigma * object@zeta**2 * object@zeta_DS) + object@sigma_P * object@sigma_S * (4 * object@supply@alpha * object@gamma * object@h_D * object@rho_SP * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@h_P * object@rho_DS * object@price_equation@sigma * object@zeta**2 - 2 * object@supply@alpha * object@gamma * object@h_S * object@rho_DP * object@price_equation@sigma * object@zeta**2 + 4 * object@supply@alpha * object@h_D * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - 4 * object@supply@alpha * object@h_D * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_P * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@supply@alpha * object@h_P * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta**2 - 2 * object@supply@alpha * object@h_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@supply@alpha * object@h_S * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta**2 + 2 * object@delta * object@h_D * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@delta * object@h_P * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta**2 - object@delta * object@h_S * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta**2) + object@var_S * (-2 * object@gamma * object@h_D * object@rho_SP**2 * object@price_equation@sigma * object@zeta**2 + object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@price_equation@sigma * object@zeta**2 - object@gamma * object@h_P * object@price_equation@sigma * object@zeta**2 * object@zeta_DP + object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@price_equation@sigma * object@zeta**2 - 2 * object@h_D * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@zeta**2 + 2 * object@h_D * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**2 + object@h_P * object@rho_DS * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@h_P * object@rho_DS * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2 - object@h_P * object@rho_dp * object@demand@sigma * object@zeta**2 * object@zeta_DP + object@h_P * object@rho_sp * object@supply@sigma * object@zeta**2 * object@zeta_DP + object@h_S * object@rho_DP * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**2 - object@h_S * object@rho_DP * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**2))) + object@var_P * object@var_S * object@zeta_DD**4 * (object@demand@alpha**2 * object@gamma * object@h_D * object@price_equation@sigma * object@zeta**2 + object@demand@alpha**2 * object@h_D * object@rho_dp * object@demand@sigma * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@rho_sp * object@supply@sigma * object@zeta**2 + object@demand@alpha * object@delta * object@h_D * object@rho_dp * object@demand@sigma * object@zeta**2) + object@zeta_DD**(7 / 2) * (object@var_D * object@var_S * (object@gamma * object@omega_S * object@rho_DP * object@price_equation@sigma * object@zeta_DP + object@gamma * object@omega_S * object@rho_SP * object@price_equation@sigma * object@zeta_SP - object@gamma * object@rho_DP * object@price_equation@sigma * object@z_PS * object@zeta**2 + object@omega_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta_DP - object@omega_S * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta_DP + object@omega_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta_SP - object@omega_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta_SP - object@rho_DP * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**2 + object@rho_DP * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**2) + object@var_P * (object@var_D * (object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@price_equation@sigma * object@zeta_DS + object@supply@alpha**2 * object@gamma * object@omega_S * object@rho_SP * object@price_equation@sigma * object@zeta_SP - object@supply@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma * object@z_SP * object@zeta**2 + object@supply@alpha**2 * object@omega_S * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta_DS - object@supply@alpha**2 * object@omega_S * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta_DS + object@supply@alpha**2 * object@omega_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta_SP - object@supply@alpha**2 * object@omega_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**2 + object@supply@alpha**2 * object@rho_DS * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**2 + object@supply@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@omega_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta_SP - object@supply@alpha * object@delta * object@rho_DS * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@gamma * object@omega_S * object@price_equation@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@gamma * object@price_equation@sigma * object@z_SP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_dp * object@demand@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_sp * object@supply@sigma * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**2 - object@demand@alpha * object@delta * object@omega_S * object@rho_sp * object@supply@sigma * object@zeta_DS + object@demand@alpha * object@delta * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**2 - object@supply@alpha * object@delta * object@omega_S * object@rho_dp * object@demand@sigma * object@zeta_DS + object@supply@alpha * object@delta * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DP * object@price_equation@sigma * object@zeta_DP + object@demand@alpha**2 * object@gamma * object@omega_S * object@rho_DS * object@price_equation@sigma * object@zeta_DS - object@demand@alpha**2 * object@gamma * object@rho_DP * object@price_equation@sigma * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@gamma * object@rho_DS * object@price_equation@sigma * object@z_SP * object@zeta**2 + object@demand@alpha**2 * object@omega_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta_DP - object@demand@alpha**2 * object@omega_S * object@rho_DP * object@rho_sp * object@supply@sigma * object@zeta_DP + object@demand@alpha**2 * object@omega_S * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta_DS - object@demand@alpha**2 * object@omega_S * object@rho_DS * object@rho_sp * object@supply@sigma * object@zeta_DS - object@demand@alpha**2 * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**2 + object@demand@alpha**2 * object@rho_DP * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@rho_DS * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**2 + object@demand@alpha**2 * object@rho_DS * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**2 + object@demand@alpha * object@delta * object@omega_S * object@rho_DP * object@rho_dp * object@demand@sigma * object@zeta_DP + object@demand@alpha * object@delta * object@omega_S * object@rho_DS * object@rho_dp * object@demand@sigma * object@zeta_DS - object@demand@alpha * object@delta * object@rho_DP * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**2 - object@demand@alpha * object@delta * object@rho_DS * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@omega_S * object@price_equation@sigma * object@zeta_SP - 2 * object@supply@alpha * object@omega_S * object@rho_dp * object@demand@sigma * object@zeta_SP + 2 * object@supply@alpha * object@omega_S * object@rho_sp * object@supply@sigma * object@zeta_SP - object@delta * object@omega_S * object@rho_sp * object@supply@sigma * object@zeta_SP) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@gamma * object@omega_S * object@price_equation@sigma * object@zeta_DP + 2 * object@demand@alpha * object@gamma * object@price_equation@sigma * object@z_PS * object@zeta**2 - 2 * object@demand@alpha * object@omega_S * object@rho_dp * object@demand@sigma * object@zeta_DP + 2 * object@demand@alpha * object@omega_S * object@rho_sp * object@supply@sigma * object@zeta_DP + 2 * object@demand@alpha * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**2 - 2 * object@demand@alpha * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**2 - object@delta * object@omega_S * object@rho_dp * object@demand@sigma * object@zeta_DP + object@delta * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (object@var_P * (-object@supply@alpha**2 * object@gamma * object@price_equation@sigma * object@zeta**3 - object@supply@alpha**2 * object@rho_dp * object@demand@sigma * object@zeta**3 + object@supply@alpha**2 * object@rho_sp * object@supply@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@rho_sp * object@supply@sigma * object@zeta**3) + object@var_S * (-object@gamma * object@price_equation@sigma * object@zeta**3 - object@rho_dp * object@demand@sigma * object@zeta**3 + object@rho_sp * object@supply@sigma * object@zeta**3)) + object@zeta_DD**(5 / 2) * (object@var_P * (object@supply@alpha**2 * object@gamma * object@h_P * object@h_S * object@rho_SP * object@price_equation@sigma * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@rho_SP**2 * object@price_equation@sigma * object@zeta**3 + object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**3 - object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**3 - object@supply@alpha**2 * object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@zeta**3 + object@supply@alpha**2 * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**3 + object@supply@alpha * object@delta * object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**3 - object@supply@alpha * object@delta * object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**3) + object@sigma_P * object@sigma_S * (-2 * object@supply@alpha * object@gamma * object@h_P * object@h_S * object@price_equation@sigma * object@zeta**3 + 2 * object@supply@alpha * object@gamma * object@rho_SP * object@price_equation@sigma * object@zeta**3 - 2 * object@supply@alpha * object@h_P * object@h_S * object@rho_dp * object@demand@sigma * object@zeta**3 + 2 * object@supply@alpha * object@h_P * object@h_S * object@rho_sp * object@supply@sigma * object@zeta**3 + 2 * object@supply@alpha * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**3 - 2 * object@supply@alpha * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**3 - object@delta * object@h_P * object@h_S * object@rho_sp * object@supply@sigma * object@zeta**3 + object@delta * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**3) + object@var_S * (object@gamma * object@h_P * object@h_S * object@rho_SP * object@price_equation@sigma * object@zeta**3 - object@gamma * object@rho_SP**2 * object@price_equation@sigma * object@zeta**3 + object@h_P * object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@zeta**3 - object@h_P * object@h_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@zeta**3 - object@rho_SP**2 * object@rho_dp * object@demand@sigma * object@zeta**3 + object@rho_SP**2 * object@rho_sp * object@supply@sigma * object@zeta**3)) + object@zeta_DD**3 * (object@var_P * (object@supply@alpha**2 * object@gamma * object@h_S * object@price_equation@sigma * object@z_SP * object@zeta**3 + object@supply@alpha**2 * object@h_S * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**3 + object@supply@alpha * object@delta * object@h_S * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**3) + object@var_S * (object@gamma * object@h_P * object@price_equation@sigma * object@z_PS * object@zeta**3 + object@h_P * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**3 - object@h_P * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**3)) + object@zeta_DD**2 * (object@var_P * (-object@supply@alpha**2 * object@gamma * object@h_P * object@rho_SP * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@gamma * object@h_S * object@rho_SP * object@price_equation@sigma * object@z_PS * object@zeta**3 - object@supply@alpha**2 * object@h_P * object@rho_SP * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**3 + object@supply@alpha**2 * object@h_P * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**3 + object@supply@alpha**2 * object@h_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**3 - object@supply@alpha * object@delta * object@h_P * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**3 - object@supply@alpha * object@delta * object@h_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**3) + object@sigma_P * object@sigma_S * (2 * object@supply@alpha * object@gamma * object@h_P * object@price_equation@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@gamma * object@h_S * object@price_equation@sigma * object@z_PS * object@zeta**3 + 2 * object@supply@alpha * object@h_P * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**3 - 2 * object@supply@alpha * object@h_P * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@h_S * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**3 - 2 * object@supply@alpha * object@h_S * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**3 + object@delta * object@h_P * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**3 + object@delta * object@h_S * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**3) + object@var_S * (-object@gamma * object@h_P * object@rho_SP * object@price_equation@sigma * object@z_SP * object@zeta**3 - object@gamma * object@h_S * object@rho_SP * object@price_equation@sigma * object@z_PS * object@zeta**3 - object@h_P * object@rho_SP * object@rho_dp * object@demand@sigma * object@z_SP * object@zeta**3 + object@h_P * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_SP * object@zeta**3 - object@h_S * object@rho_SP * object@rho_dp * object@demand@sigma * object@z_PS * object@zeta**3 + object@h_S * object@rho_SP * object@rho_sp * object@supply@sigma * object@z_PS * object@zeta**3))))) / (2 * object@delta**2 * object@var_D * object@var_P * object@var_S * object@price_equation@sigma * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_own_other_correlation", function(object) {
  standardGeneric("partial_own_other_correlation")
})

setMethod("partial_own_other_correlation", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  -object@demand@sigma * object@supply@sigma * (object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@var_P * object@zeta_SS**4 * (object@demand@alpha * object@supply@alpha * object@h_S * object@zeta**2 - object@supply@alpha * object@gamma * object@h_S * object@zeta**2) + object@var_S * (object@zeta_SS**(5 / 2) * (object@omega_D * object@rho_DP**2 * object@var_D * object@zeta**2 + object@sigma_D * object@sigma_P * (-object@demand@alpha * object@omega_D * object@rho_DP * object@zeta**2 - object@supply@alpha * object@omega_D * object@rho_DP * object@zeta**2 - object@gamma * object@omega_D * object@rho_DP * object@zeta**2) + object@var_P * (object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DP**2 * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_D * object@rho_DP**2 * object@zeta**2)) + object@zeta_SS**3 * (object@var_D * (object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 + object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - object@h_P * object@zeta**2 * object@zeta_SP - 2 * object@h_S * object@rho_DP**2 * object@zeta**2) + object@sigma_D * object@sigma_P * (-object@demand@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@demand@alpha * object@h_P * object@rho_DS * object@zeta**2 + 2 * object@demand@alpha * object@h_S * object@rho_DP * object@zeta**2 - object@supply@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@supply@alpha * object@h_P * object@rho_DS * object@zeta**2 + 2 * object@supply@alpha * object@h_S * object@rho_DP * object@zeta**2 - object@gamma * object@h_D * object@rho_SP * object@zeta**2 - object@gamma * object@h_P * object@rho_DS * object@zeta**2 + 2 * object@gamma * object@h_S * object@rho_DP * object@zeta**2) + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@h_S * object@rho_DP**2 * object@zeta**2 + object@demand@alpha * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha * object@gamma * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha * object@gamma * object@h_S * object@rho_DP**2 * object@zeta**2))) + object@zeta_SS**(7 / 2) * (object@var_D * object@var_S * (object@omega_D * object@rho_DP * object@zeta_DP + object@omega_D * object@rho_SP * object@zeta_SP - object@rho_SP * object@z_PD * object@zeta**2) + object@var_P * (object@var_D * (object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DS * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_SP * object@zeta_SP - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_DP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@rho_SP * object@z_PD * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_D * object@rho_DS * object@zeta_DS - object@supply@alpha * object@gamma * object@omega_D * object@rho_SP * object@zeta_SP + object@supply@alpha * object@gamma * object@rho_DS * object@z_DP * object@zeta**2 + object@supply@alpha * object@gamma * object@rho_SP * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@omega_D * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@z_DP * object@zeta**2 + object@delta * object@gamma * object@omega_D * object@zeta_DS - object@delta * object@gamma * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_DP * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha * object@gamma * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha * object@gamma * object@rho_DS * object@z_DP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-object@demand@alpha * object@omega_D * object@zeta_SP + object@demand@alpha * object@z_PD * object@zeta**2 - object@supply@alpha * object@omega_D * object@zeta_SP + object@supply@alpha * object@z_PD * object@zeta**2 + object@gamma * object@omega_D * object@zeta_SP - object@gamma * object@z_PD * object@zeta**2) + object@sigma_D * object@var_S * (-object@demand@alpha * object@omega_D * object@zeta_DP - object@supply@alpha * object@omega_D * object@zeta_DP - object@gamma * object@omega_D * object@zeta_DP)))) + object@var_S * (object@zeta_SS**(7 / 2) * (-object@var_D * object@zeta**3 + object@var_P * (-object@demand@alpha * object@supply@alpha * object@zeta**3 - object@demand@alpha * object@gamma * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@var_D * (object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@rho_DP**2 * object@zeta**3) + object@sigma_D * object@sigma_P * (-object@demand@alpha * object@h_D * object@h_P * object@zeta**3 + object@demand@alpha * object@rho_DP * object@zeta**3 - object@supply@alpha * object@h_D * object@h_P * object@zeta**3 + object@supply@alpha * object@rho_DP * object@zeta**3 - object@gamma * object@h_D * object@h_P * object@zeta**3 + object@gamma * object@rho_DP * object@zeta**3) + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@rho_DP**2 * object@zeta**3 + object@demand@alpha * object@gamma * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha * object@gamma * object@rho_DP**2 * object@zeta**3)) + object@zeta_SS**3 * (object@h_P * object@var_D * object@z_PD * object@zeta**3 + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_D * object@z_DP * object@zeta**3 + object@demand@alpha * object@gamma * object@h_D * object@z_DP * object@zeta**3)) + object@zeta_SS**2 * (object@var_D * (-object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@h_P * object@rho_DP * object@z_DP * object@zeta**3) + object@sigma_D * object@sigma_P * (object@demand@alpha * object@h_D * object@z_PD * object@zeta**3 + object@demand@alpha * object@h_P * object@z_DP * object@zeta**3 + object@supply@alpha * object@h_D * object@z_PD * object@zeta**3 + object@supply@alpha * object@h_P * object@z_DP * object@zeta**3 + object@gamma * object@h_D * object@z_PD * object@zeta**3 + object@gamma * object@h_P * object@z_DP * object@zeta**3) + object@var_P * (-object@demand@alpha * object@supply@alpha * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@h_P * object@rho_DP * object@z_DP * object@zeta**3 - object@demand@alpha * object@gamma * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha * object@gamma * object@h_P * object@rho_DP * object@z_DP * object@zeta**3)))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@omega_S * object@rho_SP**2 * object@var_S * object@zeta**2 + object@var_P * (object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_SP**2 * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_S * object@rho_SP**2 * object@zeta**2) + object@sigma_P * object@sigma_S * (-object@demand@alpha * object@omega_S * object@rho_SP * object@zeta**2 - object@supply@alpha * object@omega_S * object@rho_SP * object@zeta**2 + object@gamma * object@omega_S * object@rho_SP * object@zeta**2)) + object@zeta_DD**3 * (object@var_P * (-2 * object@demand@alpha * object@supply@alpha * object@h_D * object@rho_SP**2 * object@zeta**2 + object@demand@alpha * object@supply@alpha * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 + object@demand@alpha * object@supply@alpha * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@h_S * object@zeta**2 * object@zeta_DS + 2 * object@supply@alpha * object@gamma * object@h_D * object@rho_SP**2 * object@zeta**2 - object@supply@alpha * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - object@supply@alpha * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 + object@supply@alpha * object@gamma * object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_P * object@sigma_S * (2 * object@demand@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@demand@alpha * object@h_P * object@rho_DS * object@zeta**2 - object@demand@alpha * object@h_S * object@rho_DP * object@zeta**2 + 2 * object@supply@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@supply@alpha * object@h_P * object@rho_DS * object@zeta**2 - object@supply@alpha * object@h_S * object@rho_DP * object@zeta**2 - 2 * object@gamma * object@h_D * object@rho_SP * object@zeta**2 + object@gamma * object@h_P * object@rho_DS * object@zeta**2 + object@gamma * object@h_S * object@rho_DP * object@zeta**2) + object@var_S * (-2 * object@h_D * object@rho_SP**2 * object@zeta**2 + object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - object@h_P * object@zeta**2 * object@zeta_DP + object@h_S * object@rho_DP * object@rho_SP * object@zeta**2))) + object@var_P * object@var_S * object@zeta_DD**4 * (object@demand@alpha * object@supply@alpha * object@h_D * object@zeta**2 + object@demand@alpha * object@gamma * object@h_D * object@zeta**2) + object@zeta_DD**(7 / 2) * (object@var_D * object@var_S * (object@omega_S * object@rho_DP * object@zeta_DP + object@omega_S * object@rho_SP * object@zeta_SP - object@rho_DP * object@z_PS * object@zeta**2) + object@var_P * (object@var_D * (object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_DS * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_SP * object@zeta_SP - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_SP * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_S * object@rho_DS * object@zeta_DS - object@supply@alpha * object@gamma * object@omega_S * object@rho_SP * object@zeta_SP + object@supply@alpha * object@gamma * object@rho_DS * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-2 * object@demand@alpha * object@supply@alpha * object@omega_S * object@zeta_DS + 2 * object@demand@alpha * object@supply@alpha * object@z_SP * object@zeta**2 + object@delta * object@gamma * object@omega_S * object@zeta_DS - object@delta * object@gamma * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha * object@supply@alpha * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_SP * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha * object@gamma * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha * object@gamma * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha * object@gamma * object@rho_DS * object@z_SP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-object@demand@alpha * object@omega_S * object@zeta_SP - object@supply@alpha * object@omega_S * object@zeta_SP + object@gamma * object@omega_S * object@zeta_SP) + object@sigma_D * object@var_S * (-object@demand@alpha * object@omega_S * object@zeta_DP + object@demand@alpha * object@z_PS * object@zeta**2 - object@supply@alpha * object@omega_S * object@zeta_DP + object@supply@alpha * object@z_PS * object@zeta**2 - object@gamma * object@omega_S * object@zeta_DP + object@gamma * object@z_PS * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (object@var_P * (-object@demand@alpha * object@supply@alpha * object@zeta**3 + object@supply@alpha * object@gamma * object@zeta**3) - object@var_S * object@zeta**3) + object@zeta_DD**(5 / 2) * (object@var_P * (object@demand@alpha * object@supply@alpha * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@rho_SP**2 * object@zeta**3 - object@supply@alpha * object@gamma * object@h_P * object@h_S * object@rho_SP * object@zeta**3 + object@supply@alpha * object@gamma * object@rho_SP**2 * object@zeta**3) + object@sigma_P * object@sigma_S * (-object@demand@alpha * object@h_P * object@h_S * object@zeta**3 + object@demand@alpha * object@rho_SP * object@zeta**3 - object@supply@alpha * object@h_P * object@h_S * object@zeta**3 + object@supply@alpha * object@rho_SP * object@zeta**3 + object@gamma * object@h_P * object@h_S * object@zeta**3 - object@gamma * object@rho_SP * object@zeta**3) + object@var_S * (object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@rho_SP**2 * object@zeta**3)) + object@zeta_DD**3 * (object@h_P * object@var_S * object@z_PS * object@zeta**3 + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_S * object@z_SP * object@zeta**3 - object@supply@alpha * object@gamma * object@h_S * object@z_SP * object@zeta**3)) + object@zeta_DD**2 * (object@var_P * (-object@demand@alpha * object@supply@alpha * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@h_S * object@rho_SP * object@z_PS * object@zeta**3 + object@supply@alpha * object@gamma * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 + object@supply@alpha * object@gamma * object@h_S * object@rho_SP * object@z_PS * object@zeta**3) + object@sigma_P * object@sigma_S * (object@demand@alpha * object@h_P * object@z_SP * object@zeta**3 + object@demand@alpha * object@h_S * object@z_PS * object@zeta**3 + object@supply@alpha * object@h_P * object@z_SP * object@zeta**3 + object@supply@alpha * object@h_S * object@z_PS * object@zeta**3 - object@gamma * object@h_P * object@z_SP * object@zeta**3 - object@gamma * object@h_S * object@z_PS * object@zeta**3) + object@var_S * (-object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@h_S * object@rho_SP * object@z_PS * object@zeta**3))))) / (object@delta**2 * object@var_D * object@var_P * object@var_S * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_own_price_correlation", function(object) {
  standardGeneric("partial_own_price_correlation")
})

setMethod("partial_own_price_correlation", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  object@gamma * object@demand@sigma * object@price_equation@sigma * (object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@supply@alpha**2 * object@h_S * object@var_D * object@var_P * object@zeta**2 * object@zeta_SS**4 + object@var_S * (object@zeta_SS**(5 / 2) * (object@omega_D * object@rho_DP**2 * object@var_D * object@zeta**2 + object@sigma_D * object@sigma_P * (-object@demand@alpha * object@omega_D * object@rho_DP * object@zeta**2 - object@supply@alpha * object@omega_D * object@rho_DP * object@zeta**2 - object@gamma * object@omega_D * object@rho_DP * object@zeta**2) + object@var_P * (object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DP**2 * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_D * object@rho_DP**2 * object@zeta**2)) + object@zeta_SS**3 * (object@var_D * (object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 + object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - object@h_P * object@zeta**2 * object@zeta_SP - 2 * object@h_S * object@rho_DP**2 * object@zeta**2) + object@sigma_D * object@sigma_P * (-object@demand@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@demand@alpha * object@h_P * object@rho_DS * object@zeta**2 + 2 * object@demand@alpha * object@h_S * object@rho_DP * object@zeta**2 - object@supply@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@supply@alpha * object@h_P * object@rho_DS * object@zeta**2 + 2 * object@supply@alpha * object@h_S * object@rho_DP * object@zeta**2 - object@gamma * object@h_D * object@rho_SP * object@zeta**2 - object@gamma * object@h_P * object@rho_DS * object@zeta**2 + 2 * object@gamma * object@h_S * object@rho_DP * object@zeta**2) + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha * object@supply@alpha * object@h_S * object@rho_DP**2 * object@zeta**2 + object@demand@alpha * object@gamma * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha * object@gamma * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha * object@gamma * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha * object@gamma * object@h_S * object@rho_DP**2 * object@zeta**2))) + object@zeta_SS**(7 / 2) * (object@var_D * object@var_S * (object@omega_D * object@rho_DP * object@zeta_DP + object@omega_D * object@rho_SP * object@zeta_SP - object@rho_SP * object@z_PD * object@zeta**2) + object@var_P * (object@var_D * (object@supply@alpha**2 * object@omega_D * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@omega_D * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@rho_SP * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-object@demand@alpha * object@supply@alpha * object@omega_D * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@z_DP * object@zeta**2 - object@supply@alpha**2 * object@omega_D * object@zeta_DS + object@supply@alpha**2 * object@z_DP * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_D * object@zeta_DS + object@supply@alpha * object@gamma * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_DP * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha * object@gamma * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha * object@gamma * object@rho_DS * object@z_DP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-2 * object@supply@alpha * object@omega_D * object@zeta_SP + 2 * object@supply@alpha * object@z_PD * object@zeta**2) + object@sigma_D * object@var_S * (-object@demand@alpha * object@omega_D * object@zeta_DP - object@supply@alpha * object@omega_D * object@zeta_DP - object@gamma * object@omega_D * object@zeta_DP)))) + object@var_S * (object@zeta_SS**(7 / 2) * (-object@var_D * object@zeta**3 + object@var_P * (-object@demand@alpha * object@supply@alpha * object@zeta**3 - object@demand@alpha * object@gamma * object@zeta**3)) + object@zeta_SS**(5 / 2) * (object@var_D * (object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@rho_DP**2 * object@zeta**3) + object@sigma_D * object@sigma_P * (-object@demand@alpha * object@h_D * object@h_P * object@zeta**3 + object@demand@alpha * object@rho_DP * object@zeta**3 - object@supply@alpha * object@h_D * object@h_P * object@zeta**3 + object@supply@alpha * object@rho_DP * object@zeta**3 - object@gamma * object@h_D * object@h_P * object@zeta**3 + object@gamma * object@rho_DP * object@zeta**3) + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@rho_DP**2 * object@zeta**3 + object@demand@alpha * object@gamma * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha * object@gamma * object@rho_DP**2 * object@zeta**3)) + object@zeta_SS**3 * (object@h_P * object@var_D * object@z_PD * object@zeta**3 + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_D * object@z_DP * object@zeta**3 + object@demand@alpha * object@gamma * object@h_D * object@z_DP * object@zeta**3)) + object@zeta_SS**2 * (object@var_D * (-object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@h_P * object@rho_DP * object@z_DP * object@zeta**3) + object@sigma_D * object@sigma_P * (object@demand@alpha * object@h_D * object@z_PD * object@zeta**3 + object@demand@alpha * object@h_P * object@z_DP * object@zeta**3 + object@supply@alpha * object@h_D * object@z_PD * object@zeta**3 + object@supply@alpha * object@h_P * object@z_DP * object@zeta**3 + object@gamma * object@h_D * object@z_PD * object@zeta**3 + object@gamma * object@h_P * object@z_DP * object@zeta**3) + object@var_P * (-object@demand@alpha * object@supply@alpha * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@h_P * object@rho_DP * object@z_DP * object@zeta**3 - object@demand@alpha * object@gamma * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha * object@gamma * object@h_P * object@rho_DP * object@z_DP * object@zeta**3)))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@var_D * (object@zeta_DD**(5 / 2) * (object@supply@alpha**2 * object@omega_S * object@rho_SP**2 * object@var_P * object@zeta**2 - 2 * object@supply@alpha * object@omega_S * object@rho_SP * object@sigma_P * object@sigma_S * object@zeta**2 + object@omega_S * object@rho_SP**2 * object@var_S * object@zeta**2) + object@zeta_DD**3 * (object@var_P * (-2 * object@supply@alpha**2 * object@h_D * object@rho_SP**2 * object@zeta**2 + object@supply@alpha**2 * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 + object@supply@alpha**2 * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@supply@alpha**2 * object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_P * object@sigma_S * (4 * object@supply@alpha * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@supply@alpha * object@h_P * object@rho_DS * object@zeta**2 - 2 * object@supply@alpha * object@h_S * object@rho_DP * object@zeta**2) + object@var_S * (-2 * object@h_D * object@rho_SP**2 * object@zeta**2 + object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - object@h_P * object@zeta**2 * object@zeta_DP + object@h_S * object@rho_DP * object@rho_SP * object@zeta**2))) + object@var_P * object@var_S * object@zeta_DD**4 * (object@demand@alpha * object@supply@alpha * object@h_D * object@zeta**2 + object@demand@alpha * object@gamma * object@h_D * object@zeta**2) + object@zeta_DD**(7 / 2) * (object@var_D * object@var_S * (object@omega_S * object@rho_DP * object@zeta_DP + object@omega_S * object@rho_SP * object@zeta_SP - object@rho_DP * object@z_PS * object@zeta**2) + object@var_P * (object@var_D * (object@supply@alpha**2 * object@omega_S * object@rho_DS * object@zeta_DS + object@supply@alpha**2 * object@omega_S * object@rho_SP * object@zeta_SP - object@supply@alpha**2 * object@rho_DS * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-object@demand@alpha * object@supply@alpha * object@omega_S * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@z_SP * object@zeta**2 - object@supply@alpha**2 * object@omega_S * object@zeta_DS + object@supply@alpha**2 * object@z_SP * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_S * object@zeta_DS + object@supply@alpha * object@gamma * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha * object@supply@alpha * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_SP * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha * object@gamma * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha * object@gamma * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha * object@gamma * object@rho_DS * object@z_SP * object@zeta**2)) + object@sigma_P * (-2 * object@supply@alpha * object@omega_S * object@var_D * object@sigma_S * object@zeta_SP + object@sigma_D * object@var_S * (-object@demand@alpha * object@omega_S * object@zeta_DP + object@demand@alpha * object@z_PS * object@zeta**2 - object@supply@alpha * object@omega_S * object@zeta_DP + object@supply@alpha * object@z_PS * object@zeta**2 - object@gamma * object@omega_S * object@zeta_DP + object@gamma * object@z_PS * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (-object@supply@alpha**2 * object@var_P * object@zeta**3 - object@var_S * object@zeta**3) + object@zeta_DD**(5 / 2) * (object@var_P * (object@supply@alpha**2 * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@supply@alpha**2 * object@rho_SP**2 * object@zeta**3) + object@sigma_P * object@sigma_S * (-2 * object@supply@alpha * object@h_P * object@h_S * object@zeta**3 + 2 * object@supply@alpha * object@rho_SP * object@zeta**3) + object@var_S * (object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@rho_SP**2 * object@zeta**3)) + object@zeta_DD**3 * (object@supply@alpha**2 * object@h_S * object@var_P * object@z_SP * object@zeta**3 + object@h_P * object@var_S * object@z_PS * object@zeta**3) + object@zeta_DD**2 * (object@var_P * (-object@supply@alpha**2 * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@supply@alpha**2 * object@h_S * object@rho_SP * object@z_PS * object@zeta**3) + object@sigma_P * object@sigma_S * (2 * object@supply@alpha * object@h_P * object@z_SP * object@zeta**3 + 2 * object@supply@alpha * object@h_S * object@z_PS * object@zeta**3) + object@var_S * (-object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@h_S * object@rho_SP * object@z_PS * object@zeta**3))))) / (object@delta**2 * object@var_D * object@var_P * object@var_S * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})

setGeneric("partial_other_price_correlation", function(object) {
  standardGeneric("partial_other_price_correlation")
})

setMethod("partial_other_price_correlation", signature(object = "system_stochastic_adjustment"), function(object) {
  # nolint start
  -object@gamma * object@price_equation@sigma * object@supply@sigma * (object@L_D * object@zeta_DD**(7 / 2) * (object@g_D * (object@var_D * object@var_P * object@zeta_SS**4 * (object@demand@alpha * object@supply@alpha * object@h_S * object@zeta**2 - object@supply@alpha * object@gamma * object@h_S * object@zeta**2) + object@var_S * (object@zeta_SS**(5 / 2) * (object@demand@alpha**2 * object@omega_D * object@rho_DP**2 * object@var_P * object@zeta**2 - 2 * object@demand@alpha * object@omega_D * object@rho_DP * object@sigma_D * object@sigma_P * object@zeta**2 + object@omega_D * object@rho_DP**2 * object@var_D * object@zeta**2) + object@zeta_SS**3 * (object@var_D * (object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 + object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - object@h_P * object@zeta**2 * object@zeta_SP - 2 * object@h_S * object@rho_DP**2 * object@zeta**2) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@h_D * object@rho_SP * object@zeta**2 - 2 * object@demand@alpha * object@h_P * object@rho_DS * object@zeta**2 + 4 * object@demand@alpha * object@h_S * object@rho_DP * object@zeta**2) + object@var_P * (object@demand@alpha**2 * object@h_D * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha**2 * object@h_D * object@zeta**2 * object@zeta_DS + object@demand@alpha**2 * object@h_P * object@rho_DP * object@rho_DS * object@zeta**2 - 2 * object@demand@alpha**2 * object@h_S * object@rho_DP**2 * object@zeta**2))) + object@zeta_SS**(7 / 2) * (object@var_D * object@var_S * (object@omega_D * object@rho_DP * object@zeta_DP + object@omega_D * object@rho_SP * object@zeta_SP - object@rho_SP * object@z_PD * object@zeta**2) + object@var_P * (object@var_D * (object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_DS * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@omega_D * object@rho_SP * object@zeta_SP - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_DP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@rho_SP * object@z_PD * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_D * object@rho_DS * object@zeta_DS - object@supply@alpha * object@gamma * object@omega_D * object@rho_SP * object@zeta_SP + object@supply@alpha * object@gamma * object@rho_DS * object@z_DP * object@zeta**2 + object@supply@alpha * object@gamma * object@rho_SP * object@z_PD * object@zeta**2) + object@sigma_D * object@sigma_S * (-object@demand@alpha**2 * object@omega_D * object@zeta_DS + object@demand@alpha**2 * object@z_DP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@omega_D * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@z_DP * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_D * object@zeta_DS - object@demand@alpha * object@gamma * object@z_DP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@omega_D * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@omega_D * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@rho_DS * object@z_DP * object@zeta**2)) + object@sigma_P * (-2 * object@demand@alpha * object@omega_D * object@sigma_D * object@var_S * object@zeta_DP + object@var_D * object@sigma_S * (-object@demand@alpha * object@omega_D * object@zeta_SP + object@demand@alpha * object@z_PD * object@zeta**2 - object@supply@alpha * object@omega_D * object@zeta_SP + object@supply@alpha * object@z_PD * object@zeta**2 + object@gamma * object@omega_D * object@zeta_SP - object@gamma * object@z_PD * object@zeta**2)))) + object@var_S * (object@zeta_SS**(7 / 2) * (-object@demand@alpha**2 * object@var_P * object@zeta**3 - object@var_D * object@zeta**3) + object@zeta_SS**(5 / 2) * (object@var_D * (object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@rho_DP**2 * object@zeta**3) + object@sigma_D * object@sigma_P * (-2 * object@demand@alpha * object@h_D * object@h_P * object@zeta**3 + 2 * object@demand@alpha * object@rho_DP * object@zeta**3) + object@var_P * (object@demand@alpha**2 * object@h_D * object@h_P * object@rho_DP * object@zeta**3 - object@demand@alpha**2 * object@rho_DP**2 * object@zeta**3)) + object@zeta_SS**3 * (object@demand@alpha**2 * object@h_D * object@var_P * object@z_DP * object@zeta**3 + object@h_P * object@var_D * object@z_PD * object@zeta**3) + object@zeta_SS**2 * (object@var_D * (-object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@h_P * object@rho_DP * object@z_DP * object@zeta**3) + object@sigma_D * object@sigma_P * (2 * object@demand@alpha * object@h_D * object@z_PD * object@zeta**3 + 2 * object@demand@alpha * object@h_P * object@z_DP * object@zeta**3) + object@var_P * (-object@demand@alpha**2 * object@h_D * object@rho_DP * object@z_PD * object@zeta**3 - object@demand@alpha**2 * object@h_P * object@rho_DP * object@z_DP * object@zeta**3)))) + object@L_S * object@zeta_SS**(7 / 2) * (object@g_S * (object@demand@alpha**2 * object@h_D * object@var_P * object@var_S * object@zeta**2 * object@zeta_DD**4 + object@var_D * (object@zeta_DD**(5 / 2) * (object@omega_S * object@rho_SP**2 * object@var_S * object@zeta**2 + object@var_P * (object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_SP**2 * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_S * object@rho_SP**2 * object@zeta**2) + object@sigma_P * object@sigma_S * (-object@demand@alpha * object@omega_S * object@rho_SP * object@zeta**2 - object@supply@alpha * object@omega_S * object@rho_SP * object@zeta**2 + object@gamma * object@omega_S * object@rho_SP * object@zeta**2)) + object@zeta_DD**3 * (object@var_P * (-2 * object@demand@alpha * object@supply@alpha * object@h_D * object@rho_SP**2 * object@zeta**2 + object@demand@alpha * object@supply@alpha * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 + object@demand@alpha * object@supply@alpha * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@h_S * object@zeta**2 * object@zeta_DS + 2 * object@supply@alpha * object@gamma * object@h_D * object@rho_SP**2 * object@zeta**2 - object@supply@alpha * object@gamma * object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - object@supply@alpha * object@gamma * object@h_S * object@rho_DP * object@rho_SP * object@zeta**2 + object@supply@alpha * object@gamma * object@h_S * object@zeta**2 * object@zeta_DS) + object@sigma_P * object@sigma_S * (2 * object@demand@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@demand@alpha * object@h_P * object@rho_DS * object@zeta**2 - object@demand@alpha * object@h_S * object@rho_DP * object@zeta**2 + 2 * object@supply@alpha * object@h_D * object@rho_SP * object@zeta**2 - object@supply@alpha * object@h_P * object@rho_DS * object@zeta**2 - object@supply@alpha * object@h_S * object@rho_DP * object@zeta**2 - 2 * object@gamma * object@h_D * object@rho_SP * object@zeta**2 + object@gamma * object@h_P * object@rho_DS * object@zeta**2 + object@gamma * object@h_S * object@rho_DP * object@zeta**2) + object@var_S * (-2 * object@h_D * object@rho_SP**2 * object@zeta**2 + object@h_P * object@rho_DS * object@rho_SP * object@zeta**2 - object@h_P * object@zeta**2 * object@zeta_DP + object@h_S * object@rho_DP * object@rho_SP * object@zeta**2))) + object@zeta_DD**(7 / 2) * (object@var_D * object@var_S * (object@omega_S * object@rho_DP * object@zeta_DP + object@omega_S * object@rho_SP * object@zeta_SP - object@rho_DP * object@z_PS * object@zeta**2) + object@var_P * (object@var_D * (object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_DS * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@omega_S * object@rho_SP * object@zeta_SP - object@demand@alpha * object@supply@alpha * object@rho_DS * object@z_SP * object@zeta**2 - object@supply@alpha * object@gamma * object@omega_S * object@rho_DS * object@zeta_DS - object@supply@alpha * object@gamma * object@omega_S * object@rho_SP * object@zeta_SP + object@supply@alpha * object@gamma * object@rho_DS * object@z_SP * object@zeta**2) + object@sigma_D * object@sigma_S * (-object@demand@alpha**2 * object@omega_S * object@zeta_DS + object@demand@alpha**2 * object@z_SP * object@zeta**2 - object@demand@alpha * object@supply@alpha * object@omega_S * object@zeta_DS + object@demand@alpha * object@supply@alpha * object@z_SP * object@zeta**2 + object@demand@alpha * object@gamma * object@omega_S * object@zeta_DS - object@demand@alpha * object@gamma * object@z_SP * object@zeta**2) + object@var_S * (object@demand@alpha**2 * object@omega_S * object@rho_DP * object@zeta_DP + object@demand@alpha**2 * object@omega_S * object@rho_DS * object@zeta_DS - object@demand@alpha**2 * object@rho_DP * object@z_PS * object@zeta**2 - object@demand@alpha**2 * object@rho_DS * object@z_SP * object@zeta**2)) + object@sigma_P * (object@var_D * object@sigma_S * (-object@demand@alpha * object@omega_S * object@zeta_SP - object@supply@alpha * object@omega_S * object@zeta_SP + object@gamma * object@omega_S * object@zeta_SP) + object@sigma_D * object@var_S * (-2 * object@demand@alpha * object@omega_S * object@zeta_DP + 2 * object@demand@alpha * object@z_PS * object@zeta**2)))) + object@var_D * (object@zeta_DD**(7 / 2) * (object@var_P * (-object@demand@alpha * object@supply@alpha * object@zeta**3 + object@supply@alpha * object@gamma * object@zeta**3) - object@var_S * object@zeta**3) + object@zeta_DD**(5 / 2) * (object@var_P * (object@demand@alpha * object@supply@alpha * object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@rho_SP**2 * object@zeta**3 - object@supply@alpha * object@gamma * object@h_P * object@h_S * object@rho_SP * object@zeta**3 + object@supply@alpha * object@gamma * object@rho_SP**2 * object@zeta**3) + object@sigma_P * object@sigma_S * (-object@demand@alpha * object@h_P * object@h_S * object@zeta**3 + object@demand@alpha * object@rho_SP * object@zeta**3 - object@supply@alpha * object@h_P * object@h_S * object@zeta**3 + object@supply@alpha * object@rho_SP * object@zeta**3 + object@gamma * object@h_P * object@h_S * object@zeta**3 - object@gamma * object@rho_SP * object@zeta**3) + object@var_S * (object@h_P * object@h_S * object@rho_SP * object@zeta**3 - object@rho_SP**2 * object@zeta**3)) + object@zeta_DD**3 * (object@h_P * object@var_S * object@z_PS * object@zeta**3 + object@var_P * (object@demand@alpha * object@supply@alpha * object@h_S * object@z_SP * object@zeta**3 - object@supply@alpha * object@gamma * object@h_S * object@z_SP * object@zeta**3)) + object@zeta_DD**2 * (object@var_P * (-object@demand@alpha * object@supply@alpha * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@demand@alpha * object@supply@alpha * object@h_S * object@rho_SP * object@z_PS * object@zeta**3 + object@supply@alpha * object@gamma * object@h_P * object@rho_SP * object@z_SP * object@zeta**3 + object@supply@alpha * object@gamma * object@h_S * object@rho_SP * object@z_PS * object@zeta**3) + object@sigma_P * object@sigma_S * (object@demand@alpha * object@h_P * object@z_SP * object@zeta**3 + object@demand@alpha * object@h_S * object@z_PS * object@zeta**3 + object@supply@alpha * object@h_P * object@z_SP * object@zeta**3 + object@supply@alpha * object@h_S * object@z_PS * object@zeta**3 - object@gamma * object@h_P * object@z_SP * object@zeta**3 - object@gamma * object@h_S * object@z_PS * object@zeta**3) + object@var_S * (-object@h_P * object@rho_SP * object@z_SP * object@zeta**3 - object@h_S * object@rho_SP * object@z_PS * object@zeta**3))))) / (object@delta**2 * object@var_D * object@var_P * object@var_S * object@zeta**3 * object@zeta_DD**(7 / 2) * object@zeta_SS**(7 / 2))
  # nolint end
})
